{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{               ALAP16.PAS                }
{-----------------------------------------}

Program Alap16 ;

Uses
  Crt ;

Type
  Sorrendiseg = (Csokkeno,Egyforma,Novekvo) ;

Var
  A,B : Integer ;

Procedure A_Olvas ;
  Begin
    GotoXY(20,1) ;
    Write('A= ') ;
    ReadLn(A) ;
  End ;

Procedure B_Olvas ;
  Begin
    GotoXY(50,1) ;
    Write('B= ') ;
    ReadLn(B) ;
  End ;

Procedure ElteresKiir(Szam1, Szam2: Integer) ;
  Begin
    WriteLn('A kt szm kzti eltrs: ',Abs(Szam1 - Szam2)) ;
  End ;

Procedure ParosKiir(Tol, Ig: Integer) ;
  Var
    I : Integer ;
  Begin
    Write(Tol,' s ',Ig,' kz es pros szmok: ') ;
    If Tol <= Ig
    Then
      Begin
        For I := Tol To Ig Do
          If Not Odd(I) Then
            Write(I:3) ;
      End
    Else
      For I := Tol DownTo Ig Do
        If Not Odd(I) Then
          Write(I:3) ;
    WriteLn ;
  End ;

Function Sorrend(N, M: Integer) : Sorrendiseg ;
  Begin
    If N = M
    Then
      Sorrend := Egyforma
    Else
      If N < M
      Then
        Sorrend := Novekvo
      Else
        Sorrend := Csokkeno ;
  End ;

Function Minimum(X, Y: Integer): Integer ;
  Begin
    If X < Y
    Then
      Minimum := X
    Else
      Minimum := Y ;
  End ;

Function Joteglalap(Szelesseg, Magassag: Integer): Boolean ;
  Begin
    Joteglalap := (Szelesseg <= 80) And (Magassag <= 25) And
                  Not ((Szelesseg = 80) And (Magassag = 25)) ;
  End ;

Procedure Teglarajz(Szelesseg, Magassag: Integer) ;
  Var
    Oszlop,
    Sor,
    KezdX,
    KezdY : Byte ;
  Begin
    ClrScr ;
    KezdX := (80 - Szelesseg) Div 2 + 1 ;
    KezdY := (25 - Magassag) Div 2 + 1 ;
    For Sor := KezdY To KezdY + Magassag - 1 Do
      Begin
        GotoXY(KezdX,Sor) ;
        For Oszlop := 1 To Szelesseg Do
          Write(#219) ;
      End ;
  End ;

Begin
  ClrScr ;
  A_Olvas ;
  B_Olvas ;

  ElteresKiir(A,B) ;

  ParosKiir(A,B) ;

  Case Sorrend(A,B) Of
    Csokkeno : WriteLn('Cskken sorrend') ;
    Egyforma : WriteLn('Egyformk') ;
    Novekvo  : WriteLn('Nvekv sorrend') ;
  End ;

  WriteLn('A kisebb szm: ',Minimum(A,B)) ;

  If Joteglalap(A,B)
  Then
    Begin
      WriteLn('Rajzolhat tglalap') ;
      ReadLn ;
      Teglarajz(A,B) ;
    End
  Else
    WriteLn('Nem rajzolhat tglalap') ;

  ReadLn ;
End.
