{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{                DINA3.PAS                }
{-----------------------------------------}

Program Dina3 ;

{$F+,M 16384,0,655360}

Type
  RekMutato = ^Rek ;
  Rek       = Record
                Szam      : LongInt ;
                Elozo     : RekMutato ;
                Kovetkezo : RekMutato ;
              End ;
  Eljaras   = Procedure ;

Var
  ElsoRek,
  UtolsoRek,
  AktualisRek : RekMutato ;
  Szam        : LongInt ;
  Merre       : Eljaras ;

Procedure Felfuz(UjRek: RekMutato; Szam: LongInt) ;
  Var
    ElozoRek,
    AktualisRek : RekMutato ;
  Begin
    ElozoRek := Nil ;
    AktualisRek := ElsoRek ;
    {$B-}
    While (AktualisRek <> Nil) And (Szam > AktualisRek^.Szam) Do
      Begin
        ElozoRek := AktualisRek ;
        AktualisRek := AktualisRek^.Kovetkezo ;
      End ;
    {$B+}

    If ElozoRek = Nil
    Then
      ElsoRek := UjRek
    Else
      ElozoRek^.Kovetkezo := UjRek ;
    If AktualisRek = Nil
    Then
      UtolsoRek := UjRek
    Else
      AktualisRek^.Elozo := UjRek ;

    UjRek^.Szam := Szam ;
    UjRek^.Kovetkezo := AktualisRek ;
    UjRek^.Elozo := ElozoRek ;
  End ;

Procedure Elore ;
  Begin
    AktualisRek := AktualisRek^.Kovetkezo ;
  End ;

Procedure Hatra ;
  Begin
    AktualisRek := AktualisRek^.Elozo ;
  End ;

Procedure Lista(Tol: RekMutato; Tovabb: Eljaras) ;
  Begin
    AktualisRek := Tol ;
    While AktualisRek <> Nil Do
      Begin
        Write(AktualisRek^.Szam:8) ;
        Tovabb ;
      End ;
    WriteLn ;
  End ;

Begin
  ElsoRek := Nil ;
  UtolsoRek := Nil ;

  Write('Krek egy szmot : ') ;
  ReadLn(Szam) ;
  While Szam <> 0 Do
    Begin
      Felfuz(New(RekMutato),Szam) ;
      Write('Krek egy szmot : ') ;
      ReadLn(Szam) ;
    End ;
  WriteLn ;

  WriteLn('Lista elre:') ;
  Lista(ElsoRek,Elore) ;

  WriteLn('Lista visszafel:') ;
  Lista(UtolsoRek,Hatra) ;

  Release(HeapOrg) ;
  ReadLn ;
End.
