{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{                DINA7.PAS                }
{-----------------------------------------}

Program Dina7 ;

Uses
  Crt ;

Type
  KulcsTip = String[3] ;
  FaMutato = ^FaRekord ;
  FaRekord = Record
               Bal,
               Jobb  : FaMutato ;
               Kulcs : KulcsTip ;
               Adat  : String ;
             End ;

Var
  Gyoker  : FaMutato ;
  Kulcs   : KulcsTip ;
  MenuKar : Char ;

Procedure Kulcs_Beolvas ;
  Begin
    ClrScr ;
    Write('Kulcs = ') ;
    ReadLn(Kulcs) ;
  End ;

Procedure HibaUzenet(HibaSt: String) ;
  Begin
    GotoXY(25,25) ;
    Write(HibaSt) ;
  End ;

Function Van(Kulcs: KulcsTip; Var Aktualis, Szulo: FaMutato) : Boolean ;
  Var
    OK : Boolean ;
  Begin
    OK := False ;
    Aktualis := Gyoker ;
    Szulo := Nil ;
    While Not OK And (Aktualis <> Nil) Do
      Begin
        If Kulcs = Aktualis^.Kulcs
        Then
          OK := True
        Else
          Begin
            Szulo := Aktualis ;
            If Kulcs < Aktualis^.Kulcs
            Then
              Aktualis := Aktualis^.Bal
            Else
              Aktualis := Aktualis^.Jobb ;
          End ;
      End ;
    Van := OK ;
  End ;

Procedure Felvitel ;
  Var
    Aktualis,
    Uj,
    Szulo    : FaMutato ;
  Begin
    Kulcs_Beolvas ;
    If Van(Kulcs,Aktualis,Szulo)
    Then
      HibaUzenet('Mr van ilyen kulcs!')
    Else
      Begin
        New(Uj) ;
        Uj^.Kulcs := Kulcs ;
        Uj^.Bal := Nil ;
        Uj^.Jobb := Nil ;
        GotoXY(1,2) ; Write('Egyb = ') ;
        ReadLn(Uj^.Adat) ;

        If Aktualis = Gyoker
        Then
          Gyoker := Uj
        Else
          If Kulcs < Szulo^.Kulcs
          Then
            Szulo^.Bal := Uj
          Else
            Szulo^.Jobb := Uj ;
      End ;
  End ;

Procedure Torles ;
  Var
    Aktualis,
    Hely,
    Legnagobb,
    Szulo    : FaMutato ;
  Begin
    Kulcs_Beolvas ;
    If Not Van(Kulcs,Aktualis,Szulo)
    Then
      HibaUzenet('Nincs ilyen kulcs!')
    Else
      Begin
        If Aktualis^.Bal = Nil
        Then
          Hely := Aktualis^.Jobb
        Else
          Begin
            Hely := Aktualis^.Bal ;
            Legnagobb := Hely ;
            While Legnagobb^.Jobb <> Nil Do
              Legnagobb := Legnagobb^.Jobb ;
            Legnagobb^.Jobb := Aktualis^.Jobb ;
          End ;

        If Gyoker = Aktualis
        Then
          Gyoker := Hely
        Else
          If Szulo^.Bal = Aktualis
          Then
            Szulo^.Bal := Hely
          Else
            Szulo^.Jobb := Hely ;
        Dispose(Aktualis) ;
      End ;
  End ;

Procedure FaLista(Gyoker: FaMutato) ;
  Begin
    If Gyoker <> Nil
    Then
      Begin
        FaLista(Gyoker^.Bal) ;
        With Gyoker^ Do
          WriteLn(Kulcs,'':5-Length(Kulcs),Adat) ;
        FaLista(Gyoker^.Jobb) ;
      End ;
  End ;

Begin
  Gyoker := Nil ;

  ClrScr ;
  GotoXY(30,10) ; Write ('Felvitel_____F') ;
  GotoXY(30,12) ; Write ('Trls_______T') ;
  GotoXY(30,14) ; Write ('Vge_________V') ;
  Repeat
      Window(1,1,80,25) ;
      GotoXY(44,14) ;
      Repeat
        MenuKar := Upcase(ReadKey) ;
      Until MenuKar In ['F','T','V'] ;
      Window(30,20,80,25) ;
      Case MenuKar Of
        'F' : Felvitel ;
        'T' : Torles ;
      End ;
      Window(2,2,25,24) ;
      ClrScr ;
      FaLista(Gyoker) ;
  Until MenuKar = 'V' ;
  Window(1,1,80,25) ;
  ClrScr ;
End.
