{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{               HALMAZ4.PAS               }
{-----------------------------------------}

Program Halmaz4 ;

Uses
  Crt ;

Const
  JatekosSzam = 6 ;
  TippSzam    = 3 ;
  MaxTipp     = 20 ;
  JatekosNev  : Array [1..JatekosSzam] Of String[6] =
    ('Erzsi ','Laci  ','Gyuri ','Zsfi ','Kati  ','Dniel') ;

Var
  Tippek           : Array [1..JatekosSzam] Of Set Of 1..MaxTipp ;
  Tipp             : LongInt ;
  Jatekos,
  Tobbi,
  I                : Byte ;
  Tobbi_mondta,
  Tobbi_nem_mondta : Set Of 1..MaxTipp ;
  Puffer           : Array[1..5] Of Byte ;
  TippSt           : String[3] ;
  Kod              : Integer;

Begin
  ClrScr ;
  SetTextBuf(Input,Puffer,5) ;
  WriteLn('Krem a tippeket: ') ;
  GotoXY(10,2) ;
  For I := 1 To TippSzam Do
    Write(I:5,'.') ;
  For Jatekos := 1 To JatekosSzam Do
    Begin
      Tippek[Jatekos] := [] ;
      GotoXY(1,Jatekos + 2) ;
      WriteLn(JatekosNev[Jatekos],':') ;
      For I := 1 To TippSzam Do
        Begin
          Repeat
              GotoXY(8 + 6 * I,Jatekos + 2) ;
              ClrEol ;
              ReadLn(TippSt) ;
              Val(TippSt,Tipp,Kod) ;
          Until (Kod = 0) And (Tipp >= 1) And (Tipp <= MaxTipp)
                And Not (Tipp In Tippek[Jatekos]) ;
          Tippek[Jatekos] := Tippek[Jatekos] + [Tipp] ;
        End ;
    End ;
  WriteLn ;

  WriteLn('A kvetkez szmokat csak egy jtkos mondta: ') ;
  For Jatekos := 1 To JatekosSzam Do
    Begin
      Tobbi_mondta := [] ;
      For Tobbi := 1 To JatekosSzam Do
        If Tobbi <> Jatekos Then
          Tobbi_mondta := Tobbi_mondta + Tippek[Tobbi] ;
      Tobbi_nem_mondta := [1..MaxTipp] - Tobbi_mondta ;
      Write(JatekosNev[Jatekos],': ') ;
      For I := 1 To MaxTipp Do
        If (I In Tippek[Jatekos]) And (I In Tobbi_nem_mondta) Then
          Write(I:3) ;
      WriteLn ;
    End ;

  ReadLn ;
End.
