{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{               HALMAZ8.PAS               }
{-----------------------------------------}

Program Halmaz8 ;

Uses
  Crt,
  Dos ;

Const
  FszavakSzama    = 48 ;
  Betuk           = ['A'..'Z','a'..'z','_'] ;
  Szamok          = ['0'..'9'] ;
  Megjegyzes_nyit = '{';
  Megjegyzes_zar  = '}';
  Aposztrof       = '''' ;

Type
  St15      = String[15] ;
  Szohalmaz = Set Of 1..Fszavakszama ;
Const
  Fenntartott : Array[1..FszavakSzama] Of St15 =
    ('AND','ASM','ARRAY','BEGIN','CASE','CONST','CONSTRUCTOR',
     'DESTRUCTOR','DIV','DO','DOWNTO','ELSE','END','FILE','FOR',
     'FUNCTION','GOTO','IF','IMPLEMENTATION','IN','INLINE',
     'INTERFACE','LABEL','MOD','NIL','NOT','OBJECT','OF','OR',
     'PACKED','PROCEDURE','PROGRAM','RECORD','REPEAT','SET','SHL',
     'SHR','STRING','THEN','TO','TYPE','UNIT','UNTIL','USES',
     'VAR','WHILE','WITH','XOR') ;

Var
  DirInfo : SearchRec ;
  PasProg : Text ;
  Vege    : Boolean ;
  Fszavak,
  Osszes,
  Kozos,
  Nincs   : Szohalmaz ;
  I       : Byte ;

Procedure Olvas(Var Ch: Char) ;
  Begin
    Vege := Eof(PasProg) ;
    If Not Vege Then
      Read(PasProg,Ch) ;
  End ;

Procedure Varj(Szoveg: String; Kar: Char) ;
  Begin
    Write(Szoveg) ;
    Repeat
    Until Upcase(ReadKey) = Kar ;
    WriteLn ;
  End ;

Function Nagy(S : St15) : St15 ;
  Var
    I : Byte ;
  Begin
    For I := 1 to Length(S) Do
      S[I] := Upcase(S[I]) ;
    Nagy := S ;
  End ;

Procedure Gyujtes(S : St15) ;
  Var
    Azon : St15 ;
    N    : Word ;
    Ch   : Char ;
  Begin
    Assign(PasProg,S) ;
    Reset(PasProg) ;
    Fszavak := [] ;
    Olvas(Ch) ;
    While Not Vege Do
      Begin
        Case Ch Of
          Megjegyzes_nyit : Begin
                              Repeat
                                Olvas(Ch) ;
                              Until (Ch = Megjegyzes_zar) Or Vege;
                              Olvas(Ch) ;
                            End ;
          Aposztrof       : Begin
                              Repeat
                                Olvas(Ch) ;
                              Until (Ch = Aposztrof) Or Vege ;
                              Olvas(Ch) ;
                            End ;
          'A'..'Z',
          'a'..'z',
          '_'             : Begin
                              Azon := '' ;
                              Repeat
                                  Azon := Azon + Ch ;
                                  Olvas(Ch) ;
                              Until Not (Ch In (Betuk + Szamok))
                                    Or Vege ;
                              Azon := Nagy(Azon) ;
                              N := 1 ;
                              While (Azon <> Fenntartott[N]) And
                                    (N < FszavakSzama) Do
                                Inc(N) ;
                              If Azon = Fenntartott[N] Then
                                Fszavak := Fszavak + [N] ;
                            End ;
          Else              Repeat
                              Olvas(Ch) ;
                            Until (Ch In Betuk) Or
                                  (Ch = Megjegyzes_nyit) Or
                                  (Ch = Aposztrof) Or Vege ;
        End ;
      End ;
    Close(PasProg) ;
  End ;

Begin
  ClrScr ;
  Osszes := [] ;
  Kozos  := [1..FszavakSzama] ;
  Nincs  := [1..FszavakSzama] ;

  FindFirst('*.Pas',ReadOnly + Hidden + Archive,DirInfo) ;
  While DosError = 0 do
    Begin
      Gyujtes(DirInfo.Name) ;
      WriteLn(DirInfo.Name,' fenntartott szavai : ') ;
      For I := 1 To FszavakSzama Do
        If I In Fszavak Then
          Write(Fenntartott[I]:20) ;
      WriteLn ;
      Varj('T(ovbb)','T') ;
      Osszes := Osszes + Fszavak ;
      Kozos := Kozos * Fszavak ;
      Nincs := Nincs * ([1..FszavakSzama] - Fszavak) ;
      FindNext(DirInfo) ;
    End ;

  WriteLn('A Pascal programokban ezek a fenntartott ',
          'szavak tallhatk meg : ') ;
  For I := 1 To FszavakSzama Do
    If I In Osszes Then
      Write(Fenntartott[I]:20) ;
  WriteLn ;
  Varj('<ENTER>',#13) ;

  WriteLn('Az sszes Pascal programban megtallhatk : ') ;
  For I := 1 To FszavakSzama Do
    If I In Kozos Then
      Write(Fenntartott[I]:20) ;
  WriteLn ;
  Varj('<ENTER>',#13) ;

  WriteLn('Egyik Pascal programban sem tallhatk meg : ') ;
  For I := 1 To FszavakSzama Do
    If I In Nincs Then
      Write(Fenntartott[I]:20) ;

  WriteLn ;
  Varj('<ENTER>',#13) ;
End.
