{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{              KARLANC7.PAS               }
{-----------------------------------------}

Program Karlanc7 ;

Type
  St6  = String[6] ;
  St30 = String[30] ;

Var
  Lanc     : String ;
  MaiDatum : St6 ;

Function Nagy(S: String): String ;
  Var
    I : Byte ;
  Begin
    For I := 1 To Length(S) Do
      S[I] := UpCase(S[I]) ;
    Nagy := S ;
  End ;

Function Kis(S: String): String ;
  Var
    I : Byte ;
  Begin
    For I := 1 To Length(S) Do
      If S[I] In ['A'..'Z'] Then
        S[I] := Char(Ord(S[I]) + 32) ;
    Kis := S ;
  End ;

Function Vonal(Jel: Char ; Hossz: Byte): String ;
  Var
    I : Byte ;
  Begin
    For I := 1 To Hossz Do
      Vonal[I] := Jel ;
    Vonal[0] := Chr(Hossz) ;
  End ;

Function Bal(S: String ; Hossz: Byte): String ;
  Var
    I : Byte ;
  Begin
    S := Copy(S,1,Hossz) ;
    For I := Length(S) + 1 To Hossz Do
      S := S + ' ' ;
    Bal := S ;
  End ;

Procedure Fordit(Var S: String) ;
  Var
    Ss : String ;
    I  : Byte ;
  Begin
    Ss := '' ;
    For I := Length(S) Downto 1 Do
      Ss := Ss + S[I] ;
    S := Ss ;
  End ;

Procedure TorolKar(Var S: String ; Kar: Char) ;
  Var
    N : Byte ;
  Begin
    N := Pos(Kar,S) ;
    While N <> 0 Do
      Begin
        Delete(S,N,1) ;
        N := Pos(Kar,S) ;
      End ;
  End ;

Procedure Atalakit(Var S: String) ;
  Var
    CsillagPoz : Byte ;
  Begin
    CsillagPoz := Pos('*',S) ;
    While CsillagPoz <> 0 Do
      Begin
        Delete(S,CsillagPoz,1) ;
        Insert('&&',S,CsillagPoz) ;
        CsillagPoz := Pos('*',S) ;
      End ;
  End ;

Function Datumford(Datum: St6): St6 ;
  Begin
    Datumford := Copy(Datum,5,2) + Copy(Datum,3,2) + Copy(Datum,1,2) ;
  End ;

Function Veletlenlanc: St30 ;
  Var
    Hossz,
    I      : Byte ;
    Kar    : Char ;
  Begin
    Randomize ;
    Hossz := Random(31) ;
    Veletlenlanc[0] := Char(Hossz) ;
    For I := 1 To Hossz Do
      Begin
        Repeat
          Kar := Char(Random(Ord('Z') - Ord('0')+1) + Ord('0')) ;
        Until Kar In ['0'..'9','A'..'Z'] ;
        Veletlenlanc[I] := Kar ;
      End ;
  End ;

Begin
  Write('Lnc: ') ;
  ReadLn(Lanc) ;

  WriteLn(Vonal('/',79)) ;
  WriteLn('A lnc nagy- s kisbets formja, balra igaztva: ') ;
  WriteLn(Bal(Nagy(Lanc),30),Bal(Kis(Lanc),30)) ;

  Fordit(Lanc) ;
  WriteLn('A lnc fordtva: ',Lanc) ;

  Fordit(Lanc) ;

  Torolkar(Lanc,' ') ;
  WriteLn('A lnc szkzk nlkl: ',Lanc) ;

  WriteLn(Vonal('/',79)) ;

  Write('Dtum: ') ;
  ReadLn(MaiDatum) ;
  MaiDatum := Datumford(Maidatum) ;
  WriteLn('A dtum fordtva: ',MaiDatum) ;

  Lanc := Veletlenlanc ;
  WriteLn('Ime egy vletlenlnc: ',Lanc,' (',Length(Lanc),' hossz)') ;

  ReadLn ;
End.
