{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{                MEM12.PAS                }
{-----------------------------------------}

Program Mem12 ;

{$M 16384,0,655360}

Uses
  Graph ;

Var
  Meghajto,
  Uzemmod,
  GrafHiba,
  Ok          : Integer ;
  Oszto,
  I           : Word ;
  Mutato      : Pointer ;
  Parameter   : LongInt ;

  NagyValtozo : Array[1..60000] Of Byte ;
  C           : Char ;

Procedure MeretRajzolo(AlsoHatar,FelsoHatar,Minta : Word ;
                       Szoveg : String) ;
  Var
    Also,
    Felso  : Word ;
    S      : String ;
    SAlso,
    SFelso : String[10] ;
  Begin
    If AlsoHatar >= FelsoHatar Then
      Exit ;
    Also := GetMaxY - (AlsoHatar - CSeg) Div Oszto ;
    Felso := GetMaxY - (FelsoHatar - CSeg) Div Oszto ;
    Str(FelsoHatar,SFelso) ;
    Str(AlsoHAtar,SAlso) ;
    Str((FelsoHatar - AlsoHatar),S) ;
    S := Szoveg + ' ' + S + ' paragrafus (' + SAlso + ' - ' +
         SFelso + ')' ;
    Rectangle(0,Also,GetMaxX,Felso) ;
    If Also - Felso > 15 Then
      Begin
        Rectangle(GetMaxX Div 2 - TextWidth(S) Div 2 - 10,
                 (Also + Felso) Div 2 - TextHeight(S),
                 GetMaxX Div 2 + TextWidth(S) Div 2 + 10,
                 (Also + Felso) Div 2 + TextHeight(S)) ;
        SetTextJustify(CenterText,CenterText) ;
        OutTextXY(GetMaxX Div 2,(Also + Felso) Div 2,S) ;
      End ;

    SetFillStyle(Minta,GetColor) ;
    FloodFill(1,Also - 1,GetColor) ;
  End ;

Begin
  Meghajto := Detect ;
  InitGraph(Meghajto,Uzemmod,'') ;
  GrafHiba := GraphResult ;
  If GrafHiba <> grOk Then
    Begin
      WriteLn(GraphErrorMsg(GrafHiba)) ;
      ReadLn ;
      Halt ;
    End ;

  Oszto := (Seg(HeapEnd^) - CSeg) Div GetMaxY + 1 ;

  If ParamCount > 0 Then
    Begin
      Val(ParamStr(1),Parameter,Ok) ;
      If (Ok = 0) And (Parameter > 0) And
         (Parameter * 16 <= MemAvail)
      Then
        Begin
          For I := 1 To Parameter Do
            GetMem(Mutato,16) ;
        End
      Else
        Begin
          CloseGraph ;
          WriteLn('Hibs paramter  nincs ennyi heap') ;
          ReadLn ;
          Halt ;
        End ;
    End ;

  MeretRajzolo(CSeg,DSeg,LineFill,'KOD') ;
  MeretRajzolo(DSeg,SSeg,LtSlashFill,'ADAT') ;
  MeretRajzolo(SSeg,OvrHeapOrg,BkSlashFill,'VEREM') ;
  MeretRajzolo(Seg(HeapOrg^),Seg(HeapPtr^),WideDotFill,
               'FOGLALT HEAP') ;
  MeretRajzolo(Seg(HeapPtr^),Seg(HeapEnd^),XHatchFill,
               'SZABAD HEAP') ;
  ReadLn ;
  CloseGraph ;
End.
