{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{                MEM13.PAS                }
{-----------------------------------------}

Program Mem13 ;

{$M 16384,0,655360}

Uses
  Crt ;

Type
  MutatoRek       = Record
                      Lo, Hi : Word ;
                    End ;
  SzabadRekordMut = ^SzabadRekord ;
  SzabadRekord    = Record
                      Kovetkezo : SzabadRekordMut ;
                      Meret     : Pointer ;
                    End ;
  FoglaltRekord   = Record
                      Cime   : Pointer ;
                      Merete : Word ;
                    End ;
  Str5            = String[5] ;

Var
  FoglaloTomb     : Array[1..10] Of FoglaltRekord ;
  CiklusValt      : Byte ;
  VeletlenSzam    : Word ;

Function Hexa(Cim : Word) : Str5 ;
  Var
    S : Str5 ;
    I : Word ;
  Const
    H : Array[0..15] Of Char = '0123456789ABCDEF' ;
  Begin
    S := '' ;
    I := 4096 ;
    Repeat
        S := S + H[Cim Div I] ;
        Cim := Cim - I * (Cim Div I) ;
        I := I Div 16 ;
    Until I = 0 ;
    Hexa := '$'+ S ;
  End ;

Function BlokkMeret(Meret: Pointer): LongInt ;
  Begin
    BlokkMeret := LongInt(MutatoRek(Meret).Hi) * 16 +
                  MutatoRek(Meret).Lo ;
  End ;

Procedure SzabadListaInfo ;
  Var
    CiklusValt : Byte ;
    LyukSzam   : Word ;
    Aktualis   : SzabadRekordMut ;
  Begin
    Window(1,12,80,24) ;
    ClrScr ;
    WriteLn('A szabad blokkok listja:') ;
    LyukSzam := 0 ;
    Aktualis := FreeList ;
    While Aktualis <> HeapPtr Do
      Begin
        With SzabadRekord(Aktualis^) Do
          Begin
            Write('Kezdcm: ',
                  Hexa(MutatoRek(Aktualis).Hi),':',
                  Hexa(MutatoRek(Aktualis).Lo)) ;
            Write('  mrete: ',BlokkMeret(Meret)) ;
            WriteLn ;
            Aktualis := Kovetkezo ;
            Inc(LyukSzam) ;
          End ;
      End ;
    WriteLn('sszesen: ',LyukSzam,' ''lyuk''') ;
    WriteLn ;
    WriteLn('A heap tetejn lev egybefgg szabad terlet' +
            ' mrete:') ;
    Write(Hexa(Seg(HeapPtr^)),':',Hexa(Ofs(HeapPtr^)),' -tl ') ;
    Write(Hexa(Seg(HeapEnd^)),':',Hexa(Ofs(HeapEnd^)),' -ig ') ;
    WriteLn((Seg(HeapEnd^) * 16 + Ofs(HeapEnd^)) -
            (Seg(HeapPtr^) * 16 + Ofs(HeapPtr^)):5,' bjt') ;

    Window(1,1,80,25) ;
  End ;

Begin
  ClrScr ;
  Randomize ;
  For CiklusValt := 1 To 10 Do
    With FoglaloTomb[CiklusValt] Do
      Begin
        Merete := (Random(10000) + 1) * 2 ;
        If MemAvail < Merete Then
          Merete := 0 ;
        GetMem(Cime,Merete) ;
        GotoXY(1,CiklusValt) ;
        Write(CiklusValt:2,'. blokk - cme: ',
              Hexa(Seg(Cime^)),':',Hexa(Ofs(Cime^)),
              ' - mrete: ',Merete:5,' bjt') ;
      End ;

  For CiklusValt := 1 To 10 Do
    Begin
      VeletlenSzam := Random(10) + 1 ;
      With FoglaloTomb[VeletlenSzam] Do
        If Merete > 0 Then
          Begin
            FreeMem(Cime,Merete) ;
            GotoXY(55,VeletlenSzam) ;
            Write('blokk felszabadtva') ;
            SzabadListaInfo ;
            GotoXY(1,24) ;
            Write('Tovbbi felszabadts - <ENTER>') ;
            ReadLn ;
            Merete := 0 ;
          End ;
    End ;

    GotoXY(1,24) ;
    ClrEol ;
    Write('Vge - <ENTER>') ;
    ReadLn ;
End.
