{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{               TIPALL5.PAS               }
{-----------------------------------------}

Program Tipall5 ;

{$X+}

Uses
  Crt ;

Const
  AktEv = 1991 ;
  Napok : Array [1..12] Of 1..31 =
            (31,28,31,30,31,30,31,31,30,31,30,31) ;

Var
  AktEvStr   : String[4] ;
  Szuletesek : File Of Word ;
  Ho,
  Nap        : Byte ;
  Szulszam,
  Tol,
  Ig,
  I          : Word ;

Function SzokoEv(Ev:Word) : Boolean ;
  Begin
    SzokoEv := (Ev Mod 4 = 0) And (Ev Mod 100 <> 0) Or
               (Ev Mod 400 = 0)
  End ;

Function Evnapja (Ho, Nap: Byte) : Word ;
  Var
    NapSorsz,
    I        : Word ;
  Begin
    NapSorsz := 0 ;
    For I := 1 To Ho - 1 Do
      NapSorsz := NapSorsz + Napok[I] ;
    EvNapja := NapSorsz + Nap ;
  End ;

Procedure Datum(Evnap: Word ; Var Ho, Nap: Byte) ;
  Var
    Napokszama : Word ;
  Begin
    Ho := 1 ;
    Napokszama := 0 ;
    While Evnap > Napokszama + Napok[Ho] Do
      Begin
        Inc(Napokszama,Napok[Ho]) ;
        Inc(Ho) ;
      End ;
    Nap := Evnap - Napokszama ;
  End ;

Function Szam(X,Y: Byte; Tol,Ig: LongInt) : LongInt ;
  Var
    L : LongInt ;
  Begin
    {$I-}
    Repeat
        GotoXY(X,Y) ;
        ClrEol ;
        ReadLn(L) ;
    Until (IOResult = 0) And (L >= Tol) And (L <= Ig) ;
    {$I+}
    Szam := L ;
  End ;

Begin
  Inc(Napok[2],Ord(SzokoEv(AktEv))) ;

  Str(AktEv,AktEvStr) ;
  Assign(Szuletesek,AktEvStr + '.Dat') ;
  {$I-}
  Reset(Szuletesek) ;
  {$I+}
  If IOResult <> 0 Then
    Begin
      Rewrite(Szuletesek) ;
      Szulszam := 0 ;
      For I := 0 To EvNapja(12,31) Do
        Write(Szuletesek,Szulszam) ;
    End ;

  ClrScr ;
  WriteLn('Szletsnapok felvitele:') ;
  WriteLn('') ;
  Write('H  : ') ;
  Ho := Szam(WhereX,WhereY,0,12) ;
  While Ho <> 0 Do
    Begin
      Write('Nap : ') ;
      Nap := Szam(WhereX,WhereY,1,Napok[Ho]) ;
      Seek(Szuletesek,Evnapja(Ho,Nap)) ;
      Read(Szuletesek,Szulszam) ;
      Inc(Szulszam) ;
      Seek(Szuletesek,Evnapja(Ho,Nap)) ;
      Write(Szuletesek,Szulszam) ;
      WriteLn ;
      If WhereY >= 23 Then
        ClrScr ;
      Write('H  : ') ;
      Ho := Szam(WhereX,WhereY,0,12) ;
    End ;

  ClrScr ;
  WriteLn('Listzs adott dtumtl adott dtumig') ;
  WriteLn('') ;
  WriteLn('Kezd dtum: ') ;
  Write('H  : ') ;
  Ho := Szam(WhereX,WhereY,1,12) ;
  Write('Nap : ') ;
  Nap := Szam(WhereX,WhereY,1,Napok[Ho]) ;
  Tol := Evnapja(Ho,Nap) ;

  WriteLn('Utols dtum: ') ;
  Write('H  : ') ;
  Ho := Szam(WhereX,WhereY,1,12) ;
  Write('Nap : ') ;
  Nap := Szam(WhereX,WhereY,1,Napok[Ho]) ;
  Ig := Evnapja(Ho,Nap) ;


  Seek(Szuletesek,Tol) ;
  For I := Tol To Ig Do
    Begin
      Read(Szuletesek,Szulszam) ;
      Datum(I,Ho,Nap) ;
      WriteLn(Ho:2,'. h ',Nap:2,'. sszesen: ',Szulszam) ;
      If WhereY > 23 Then
        Begin
          ReadKey ;
          ClrScr ;
        End ;
    End ;
  ReadKey ;
End.
