{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{              TIPNELK5.PAS               }
{-----------------------------------------}

Program Tipnelk5 ;

{$I-}

Uses
  Crt,
  Dos ;

Var
  ListaFajl    : Text ;
  ForrasFajl   : File ;
  ForrasNev,
  Spec         : PathStr ;
  Katalogus    : DirStr ;
  Nev          : NameStr ;
  Kit          : ExtStr ;
  CelFajl      : File ;
  CelKatalogus : DirStr ;
  Puffer       : Array[0..32767] Of Byte ;
  Beolvasott,
  Kiirt,
  FajlSzam,
  RegiAttr     : Word ;

Begin
  ClrScr ;
  If ParamCount <> 2 Then
    Begin
      WriteLn('llomnyok msolsa listallomnybl ' +
              'clkatalgusba:') ;
      WriteLn('Hasznlat: TIPNELK3 <listallspec.> ' +
              '<[d:][katalgus]>') ;
      ReadLn ;
      Halt ;
    End ;

  Assign(ListaFajl,ParamStr(1)) ;
  Reset(ListaFajl) ;
  If IOResult <> 0 Then
    Begin
      WriteLn(ParamStr(1),' nem tallhat') ;
      ReadLn ;
      Halt ;
    End ;
  GetDir(0,Katalogus) ;
  CelKatalogus := ParamStr(2) ;
  ChDir(CelKatalogus) ;
  If IOResult <> 0 Then
    Begin
      WriteLn(CelKatalogus,' katalgus nem tallhat') ;
      ReadLn ;
      Halt ;
    End ;

  ChDir(Katalogus) ;

  FajlSzam := 0 ;
  While Not Eof(ListaFajl) Do
    Begin
      ReadLn(ListaFajl,ForrasNev) ;
      If ForrasNev <> '' Then
        Begin
          Assign(ForrasFajl,ForrasNev) ;
          FSplit(FExpand(ForrasNev),Katalogus,Nev,Kit) ;
          GetFAttr(ForrasFajl,RegiAttr) ;
          SetFAttr(ForrasFajl,Archive) ;
          Reset(ForrasFajl,1) ;
          Case IOResult Of
            0 : Begin
                  If CelKatalogus[Length(CelKatalogus)] <> '\' Then
                    CelKatalogus := CelKatalogus + '\' ;
                  WriteLn(ForrasNev,' msolsa') ;
                  Assign(CelFajl,CelKatalogus + Nev + Kit) ;
                  Rewrite(CelFajl,1) ;

                  Repeat
                      BlockRead(ForrasFajl,Puffer,
                                Sizeof(Puffer),Beolvasott) ;
                      BlockWrite(CelFajl,Puffer,Beolvasott,Kiirt);
                  Until (Beolvasott = 0) Or (Kiirt <> Beolvasott);
                  Close(ForrasFajl) ;
                  Close(CelFajl) ;

                  SetFAttr(ForrasFajl,RegiAttr) ;
                  If Kiirt <> Beolvasott
                  Then
                    Begin
                      WriteLn('Tele a lemez') ;
                      Erase(CelFajl) ;
                      ReadLn ;
                      Halt ;
                    End
                  Else
                    Inc(FajlSzam) ;
                End ;
            2 : WriteLn(ForrasNev,' *** nemltez llomny') ;
            3 : WriteLn(ForrasNev,' *** nemltez katalgus') ;
            5 : WriteLn(ForrasNev,' *** hozzfrs tiltott') ;
          End ;
        End ;
    End ;
  Close(ListaFajl) ;

  WriteLn ;
  WriteLn(FajlSzam,' llomny tmsolva') ;
  Write('  <ENTER>') ;
  ReadLn ;
End.
