{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{              TIPNELK6.PAS               }
{-----------------------------------------}

Program Tipnelk6 ;

{$I-}

Uses
  Crt ;

Type
  AllomanyLeiro = Record
                    Azonosito   : Byte ;
                    Datum       : Record
                                    Ev, Ho, Nap : Byte ;
                                  End ;
                    RekordSzam  : LongInt ;
                    AdatKezdet  : Word ;
                    RekordMeret : Word ;
                    NemHasznalt : Array[1..20] Of Byte ;
                  End ;

  MezoLeiroMut  = ^MezoLeiro ;
  MezoLeiro     = Record
                    MezoNev      : Array[1..10] Of Char ;
                    NemHasznalt1 : Byte ;
                    MezoTipus    : Char ;
                    NemHasznalt2 : Array[1..4] Of Byte ;
                    MezoHossz    : Word ;
                    NemHasznalt3 : Array[1..14] Of Byte ;
                    Kovetkezo    : MezoLeiroMut ;
                  End ;

  RekordTip     = Array[1..65521] Of Char ;

Const
   TablaHossz = 15 ;

Var
  dBaseAllomany : File ;
  AllomanyNev   : String ;
  AllomanyFej   : AllomanyLeiro ;
  Mezo          : MezoLeiro ;
  HeapAllapot,
  ElsoMezo,
  UjMezo,
  AktMezo       : MezoLeiroMut ;
  Rekord        : ^RekordTip ;
  I,
  J,
  MezoSzam,
  TablaKezd     : Word ;
  C             : Char ;
  AktRek        : LongInt ;
  Beolvasva     : Word ;

Procedure Varj ;
  Begin
    GotoXY(1,25) ;
    Write('Tovbb: <ENTER> / Vge: <ESC>') ;
    Repeat
      C := ReadKey ;
    Until C In [^M,^[] ;
    If C = ^[ Then
      Begin
        ClrScr ;
        Halt ;
      End ;
  End ;

Begin
  Write('A dBase (Clipper) llomny neve: ') ;
  ReadLn(AllomanyNev) ;
  If AllomanyNev = '' Then
    Halt ;

  Assign(dBaseAllomany,AllomanyNev) ;
  Reset(dBaseAllomany,1) ;
  If IOResult <> 0 Then
    Begin
      WriteLn('A(z) ',AllomanyNev,' llomny nem tallhat') ;
      ReadLn ;
      Halt ;
    End ;

  BlockRead(dBaseAllomany,AllomanyFej,32,Beolvasva) ;
  If Beolvasva <> 32 Then
    Begin
      WriteLn('Hiba az llomny olvassa kzben') ;
      ReadLn ;
      Halt ;
    End ;
  Mark(HeapAllapot) ;
  ElsoMezo := Nil ;
  BlockRead(dBaseAllomany,Mezo,32) ;
  While (IOResult = 0) And (Mezo.MezoNev[1] <> Char($0D)) Do
    Begin
      New(UjMezo) ;
      UjMezo^ := Mezo ;
      UjMezo^.Kovetkezo := Nil ;
      If ElsoMezo = Nil
      Then
        ElsoMezo := UjMezo
      Else
        AktMezo^.Kovetkezo := UjMezo ;
      AktMezo := UjMezo ;
      BlockRead(dBaseAllomany,Mezo,32) ;
    End ;

  ClrScr ;
  With AllomanyFej Do
    Begin
      Write('Az llomnyhoz ') ;
      If Azonosito = $03 Then
        Write('nem ') ;
      WriteLn('tartozik MEMO llomny.') ;
      With Datum Do
        WriteLn('Az utols mdosts dtuma : ',
                Ev,'-',Ho,'-',Nap) ;
      WriteLn ;
      WriteLn('Rekordok szma             : ',RekordSzam) ;
      WriteLn('Rekordmret                : ',RekordMeret,
              ' bjt') ;
    End ;

  WriteLn ;
  WriteLn('N Meznv    Tip Hossz     ' +
          'N Meznv    Tip Hossz     ' +
          'N Meznv    Tip Hossz') ;
  For I := 1 To 80 Do
    Write('') ;
  MezoSzam := 1 ;
  TablaKezd := 0 ;
  AktMezo := ElsoMezo ;
  While AktMezo <> Nil Do
    Begin
      GotoXY(28 * ((MezoSzam - 1) Div TablaHossz) + 1,
             9 + (MezoSzam - 1) Mod TablaHossz) ;
      With AktMezo^ Do
        Begin
          Write(TablaKezd + MezoSzam:2,' ') ;
          For I := 1 To 10 Do
            Write(MezoNev[I]) ;
          Write('  ',MezoTipus,'  ') ;
          Case MezoTipus Of
            'C' : Write(MezoHossz:5) ;
            'N' : Write(Lo(MezoHossz):2,'/',Hi(MezoHossz):2) ;
            Else  Write(Lo(MezoHossz):5) ;
          End ;
        End ;
      Inc(MezoSzam) ;
      If MezoSzam > TablaHossz * 3 Then
        Begin
          MezoSzam := 1 ;
          Inc(TablaKezd,TablaHossz * 3) ;
          Varj ;
          Window(1,9,80,25) ;
          ClrScr ;
          Window(1,1,80,25) ;
        End ;
      AktMezo := AktMezo^.Kovetkezo ;
    End ;
  If MezoSzam <= TablaHossz * 3 Then
    Varj ;

  ClrScr ;
  If AllomanyFej.RekordSzam = 0 Then
    Begin
      Write('Az adatllomny res...') ;
      ReadLn ;
      Halt ;
    End ;
  If AllomanyFej.RekordMeret > 65521 Then
    Begin
      Write('Az adatrekord mrete a megjelentshez tl nagy...');
      ReadLn ;
      Halt ;
    End ;

  GetMem(Rekord,AllomanyFej.RekordMeret) ;
  Seek(dBaseAllomany,AllomanyFej.AdatKezdet) ;
  AktRek := 1 ;
  While AktRek <= AllomanyFej.RekordSzam Do
    Begin
      BlockRead(dBaseAllomany,Rekord^,AllomanyFej.RekordMeret) ;
      If Rekord^[1] = ' ' Then
        Begin
          AktMezo := ElsoMezo ;
          I := 1 ;
          While AktMezo <> Nil Do
            Begin
              If AktMezo^.MezoTipus In ['C','L','D','N'] Then
                Begin
                  Write(AktMezo^.MezoNev,' : ') ;
                  For J := 1 To Lo(AktMezo^.MezoHossz) Do
                    Begin
                      If WhereY = 23 Then
                        Begin
                          Varj ;
                          ClrScr ;
                        End ;
                      If WhereX = 80 Then
                        GotoXY(14,WhereY + 1) ;
                      Case AktMezo^.MezoTipus Of
                        'D' : Begin
                                If J In [5,7] Then
                                  Write('/') ;
                                Write(Rekord^[I + J]) ;
                              End ;
                        'L' : If Rekord^[I + J] <> 'T'
                              Then
                                Write('F')
                              Else
                                Write('T') ;
                        Else  Write(Rekord^[I + J]) ;
                      End ;
                    End ;
                  WriteLn ;
                End ;
              AktMezo := AktMezo^.Kovetkezo ;
              Inc(I,J) ;
            End ;
          Varj ;
          ClrScr ;
        End ;
      Inc(AktRek) ;
    End ;

  FreeMem(Rekord,AllomanyFej.RekordMeret) ;
  Release(HeapAllapot) ;
  Close(dBaseAllomany) ;

  GotoXY(1,25) ;
  Write('Vge - <ENTER>') ;
  ReadLn ;
  ClrScr ;
End.
