{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{                TOMB9.PAS                }
{-----------------------------------------}

Program Tomb9 ;

Uses
  Crt ;

Const
  Max = 15 ;

Type
  IndexTip = 0..Max ;
  ElemTip  = String[4] ;

Var
  Sor        : Array[1..Max] Of ElemTip ;
  Elem       : ElemTip ;
  Sorban,
  ELso,
  Utolso     : IndexTip ;
  Ures,
  Tele       : Boolean ;
  Tranzakcio : Char ;

Procedure Kovetkezo(Var Index: IndexTip) ;
  Begin
    If Index = Max
    Then
      Index := 1
    Else
      Inc(Index) ;
  End ;

Procedure SorKiir ;
  Var
    I,
    Index : IndexTip ;
  Begin
    GotoXY(5,13) ;
    ClrEol ;
    Index := Elso ;
    For I := 1 To Sorban Do
      Begin
        Write(Sor[Index]:5) ;
        Kovetkezo(Index) ;
      End ;
  End ;

Procedure Sorba ;
  Begin
    If Tele Then
      Exit ;
    GotoXY(30,22) ;
    Write('A beteend elem: ') ;
    GotoXY(50,22) ;
    ReadLn(Elem) ;
    Kovetkezo(Utolso) ;
    Sor[Utolso] := Elem ;
    GotoXY(5 + 5 * Sorban,13) ;
    Write(Elem:5) ;
    Inc(Sorban) ;
    Tele := Sorban = Max ;
    Ures := False ;
  End ;

Procedure Sorbol ;
  Begin
    If Ures Then
      Exit ;
    Kovetkezo(Elso) ;
    Dec(Sorban) ;
    SorKiir ;
    Ures := Sorban = 0 ;
    Tele := False ;
  End ;

Procedure VonalHuz(X,Y, Hossz: Byte) ;
  Var
    I : Byte ;
  Begin
    GotoXY(X,Y) ;
    For I := 1 To Hossz Do
      Write(#196) ;
  End ;

Begin
  ClrScr ;
  VonalHuz(5,12,5 * Max) ;
  VonalHuz(5,14,5 * Max) ;

  Sorban := 0 ;
  Elso := 1 ;
  Utolso := 0 ;
  Tele := False ;
  Ures := True ;
  GotoXY(5,10) ;
  Write('res') ;

  GotoXY(30,20) ;
  Write('B(e)/K(i)/V(ge)') ;
  Tranzakcio := Upcase(ReadKey) ;
  While Tranzakcio <> 'V' Do
    Begin
      Case Tranzakcio Of
        'B' : Sorba ;
        'K' : Sorbol ;
      End ;
      GotoXY(30,22) ;
      ClrEol ;
      GotoXY(5,10) ;
      ClrEol ;
      If Tele Then
        Write('Tele') ;
      If Ures Then
        Write('res') ;
      GotoXY(30,20) ;
      Write('B(e)/K(i)/V(ge)') ;
      Tranzakcio := Upcase(ReadKey) ;
    End ;
  ClrScr ;
End.
