{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{               TOMB12.PAS                }
{-----------------------------------------}

Program Tomb12 ;

{$X+}

Uses
  Crt,
  Dos ;

Const
  Elemszam =  500 ;
  MinKulcs = -9999 ;
  MaxKulcs =  9999 ;

Type
  ElemTip   = Record
                Kulcs : Integer ;
                Egyeb : String[20] ;
              End ;
  TombTip   = Array [0..Elemszam] Of ElemTip ;

Var
  Tomb      : TombTip ;
  I         : Word ;
  Elso,
  Utolso,
  Kozepso   : Word ;
  Keresendo : Integer ;
  Van       : Boolean ;
  IdoKezd,
  IdoVeg    : LongInt ;

Function SzazadMasodPerc : LongInt ;
  Var
    Ora,
    Perc,
    MPerc,
    SzMPerc : Word ;
  Begin
    GetTime(Ora, Perc, MPerc, SzMPerc) ;
    SzazadMasodPerc := LongInt(1) * 100 * (60 * (60 * Ora +
                       Perc) + MPerc) + SzMPerc ;
  End ;

Procedure StopperBe ;
  Begin
    IdoKezd := SzazadMasodPerc ;
  End ;

Procedure StopperKi ;
  Begin
    IdoVeg := SzazadMasodPerc ;
  End ;

Function IdoMp : Real ;
  Begin
    IdoMp := (IdoVeg - IdoKezd) / 100 ;
  End ;

Function Veletlen(N, M: Integer): Integer ;
  Begin
    Veletlen := Random(M - N + 1) + N ;
  End ;

Procedure Tomb_General ;
  Var
    Lepes : Real ;
    I     : Word ;
  Begin
    Tomb[0].Kulcs := 0 ;
    Tomb[0].Egyeb := '' ;
    Randomize ;
    Lepes := (MaxKulcs - MinKulcs) / Elemszam ;
    Tomb[1].Kulcs := Veletlen(MinKulcs,Trunc(Minkulcs + Lepes)) ;
    For I := 2 To Elemszam Do
      Tomb[I].Kulcs := Veletlen(Tomb[I - 1].Kulcs,
                       Trunc(MinKulcs + Lepes * I));
    For I := 1 To Elemszam Do
      Begin
        Str(Tomb[I].Kulcs,Tomb[I].Egyeb) ;
        Tomb[I].Egyeb := 'Elem ' + Tomb[I].Egyeb ;
      End ;
  End ;

Procedure Kulcs_Kiir ;
  Var
    I : Word ;
  Begin
    ClrScr ;
    For I := 1 To Elemszam Do
      Begin
        If WhereY > 23 Then
          Begin
            WriteLn ;
            Write('Tovbb <ENTER>') ;
            ReadKey ;
            ClrScr ;
          End ;
        Write(Tomb[I].Kulcs:5) ;
      End ;
    WriteLn ;
  End ;

Begin
  ClrScr ;
  Tomb_General ;
  Kulcs_Kiir ;

  Write('Krem a keresend kulcsot: ') ;
  ReadLn(Keresendo) ;

  WriteLn('Lineris keress: ') ;
  StopperBe ;
  I := 1 ;
  While (I < Elemszam) And (Keresendo <> Tomb[I].Kulcs) Do
    Inc(I) ;
  Van := Keresendo = Tomb[I].Kulcs ;
  StopperKi ;
  If Van
  Then
    With Tomb[I] Do
      WriteLn('Az ',I,'.',' Kulcs= ',Kulcs,'  Egyb= ',Egyeb)
  Else
    WriteLn('Nincs') ;
  WriteLn('Keressi id: ',IdoMp:6:4,#13#10) ;
  WriteLn('Binris keress: ') ;
  StopperBe ;
  Elso := 1 ;
  Utolso := Elemszam ;
  Van := False ;
  Repeat
      Kozepso := (Elso + Utolso) Div 2 ;
      If Keresendo = Tomb[Kozepso].Kulcs
      Then
        Van := True
      Else
        If Keresendo < Tomb[Kozepso].Kulcs
        Then
          Utolso := Kozepso - 1
        Else
          Elso := Kozepso + 1 ;
  Until Van Or (Elso > Utolso) ;

  StopperKi ;
  If Van
  Then
    With Tomb[I] Do
      WriteLn('Az ',I,'.',' Kulcs= ',Kulcs,'  Egyb= ',Egyeb)
  Else
    WriteLn('Nincs') ;
  WriteLn('Keressi id: ',IdoMp:6:4) ;
  Write('<ENTER>') ;
  ReadLn ;
End.
