{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{               TOMB13.PAS                }
{-----------------------------------------}

Program Tomb13 ;

Uses
  Crt ;

Const
  MaxNev = 20 ;

Type
  St30 = String[30] ;
  St80 = String[80] ;

Var
  Nev        : St30 ;
  NevTomb    : Array [1..MaxNev] Of St30 ;
  NevekSzama,
  Index      : Word ;
  MenuKar    : Char ;

Procedure Nevolvas ;
  Begin
    GotoXY(40,22) ;
    ClrEol ;
    ReadLn(Nev) ;
  End ;

Procedure HibaIr(Szoveg: St80) ;
  Begin
    GotoXY(35,24) ;
    Write(Szoveg) ;
    Delay(1000) ;
    GotoXY(35,24) ;
    ClrEol ;
  End ;

Function Van(Var Poz: Word): Boolean ;
  Var
    Stop : Boolean ;
  Begin
    Poz := 1 ;
    Stop := False ;
    While (Poz <= NevekSzama) And Not Stop Do
      If (Nev > NevTomb[Poz])
      Then
        Inc(Poz)
      Else
        Stop := True ;
    If Stop
    Then
      Van := Nev = NevTomb[Poz]
    Else
      Van := False ;
  End ;

Procedure Beszur(Poz: Word) ;
  Var
    I : Word ;
  Begin
    For I := NevekSzama DownTo Poz Do
      NevTomb[I + 1] := NevTomb[I] ;
    Inc(NevekSzama) ;
    NevTomb[Poz] := Nev ;
  End ;

Procedure Torol(Poz: Word) ;
  Var
    I : Word ;
  Begin
    Dec(NevekSzama) ;
    For I := Poz To NevekSzama Do
      NevTomb[I] := NevTomb[I + 1] ;
  End ;

Procedure Lista ;
  Var
    I : Word ;
  Begin
    GotoXY(1,1) ;
    For I := 1 To NevekSzama Do
      WriteLn(NevTomb[I],'':30 - Length(NevTomb[I])) ;
    For I := NevekSzama + 1 To MaxNev Do
      WriteLn('':30) ;
  End ;

Begin
  NevekSzama := 0 ;
  ClrSCr ;
  GotoXY(35,12) ; Write('Beszr.............B') ;
  GotoXY(35,14) ; Write('Trl..............T') ;
  GotoXY(35,16) ; Write('Vge...............V') ;

  GotoXY(35,22) ; Write('Nv:') ;
  Repeat
      GotoXY(55,16) ;
      MenuKar := Upcase(ReadKey) ;
      Case MenuKar Of
        'B' : If NevekSzama = MaxNev
              Then
                HibaIr('Nincs tbb hely')
              Else
                Begin
                  Nevolvas ;
                  If Van(Index)
                  Then
                    HibaIr('Mr van')
                  Else
                    Begin
                      Beszur(Index) ;
                      Lista ;
                    End ;
                End ;
        'T' : If NevekSzama = 0
              Then
                HibaIr('Nincs egy nv sem')
              Else
                Begin
                  Nevolvas ;
                  If Van(Index)
                  Then
                    Begin
                      Torol(Index) ;
                      Lista ;
                    End
                  Else
                    HibaIr('Nincs ilyen nv') ;
                End ;
      End ;
  Until MenuKar = 'V' ;
  ClrScr ;
End.
