{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{                DINA4.PAS                }
{-----------------------------------------}

Program Dina4 ;

{$M 16384,0,655360}
{$V-}

Uses
  Dos,
  Crt ;

Var
  Listazando : PathStr ;

Procedure KatalogusLista(AllSpec: PathStr) ;
  Type
    NevRekMut = ^NevRek ;
    NevRek    = Record
                  Nev        : String[12] ;
                  Attributum : Word ;
                  Kov        : NevRekMut ;
                End ;

  Var
    HeapTeto     : Pointer ;
    Bejegyzes    : SearchRec ;
    ElsoRek,
    AktualisRek,
    ElozoRek,
    UjRek        : NevRekMut ;
    Sorsz        : Byte ;

  Procedure Varj ;
    Begin
      LowVideo ;
      Write('   Tovbb = <ENTER>') ;
      Repeat
      Until ReadKey = ^M ;
      ClrScr ;
    End ;

  Begin
    Mark(HeapTeto) ;
    If AllSpec = ''
    Then
      AllSpec := '*.*'
    Else
      Begin
        AllSpec := FExpand(AllSpec) ;
        If (Pos('.',AllSpec) = 0) And (Pos('*',AllSpec) = 0) And
           (Pos('?',AllSpec) = 0) Then
          Begin
            If Copy(AllSpec,Length(AllSpec),1) <> '\' Then
              AllSpec := AllSpec + '\' ;
            AllSpec := AllSpec + '*.*' ;
          End ;
      End ;

    FindFirst(AllSpec,Archive + ReadOnly + Directory,Bejegyzes) ;
    Case DosError Of
      0   : Begin
              ElsoRek := Nil ;
              While DosError = 0 Do
                Begin
                  New(UjRek) ;
                  With UjRek^ , Bejegyzes Do
                    Begin
                      Nev := Name ;
                      Attributum := Attr ;
                    End ;
                  ElozoRek := Nil ;
                  AktualisRek := ElsoRek ;
                  {$B-}
                  While (AktualisRek <> Nil) And
                        (Bejegyzes.Name > AktualisRek^.Nev) Do
                    Begin
                      ElozoRek := AktualisRek ;
                      AktualisRek := AktualisRek^.Kov ;
                    End ;
                  {$B+}

                  If ElozoRek = Nil
                  Then
                    ElsoRek := Ujrek
                  Else
                    ElozoRek^.Kov := UjRek ;
                  UjRek^.Kov := AktualisRek ;

                  FindNext(Bejegyzes) ;
                End ;
              Sorsz := 0 ;
              AktualisRek := ElsoRek ;
              While AktualisRek <> Nil Do
                Begin
                  With AktualisRek^ Do
                    Begin
                      If Attributum And Directory = Directory
                      Then
                        HighVideo
                      Else
                        LowVideo ;
                      Inc(Sorsz) ;
                      WriteLn(Nev,'':8 - Length(Nev)) ;
                      If Sorsz = 24 Then
                        Begin
                          Varj ;
                          Sorsz := 1 ;
                        End ;
                    End ;
                  AktualisRek := AktualisRek^.Kov ;
                End ;
            End ;
      18  : WriteLn('Nincs ilyen llomny') ;
      3   : WriteLn('A katalgus nem tallhat') ;
      152 : WriteLn('A lemezegysg zemkptelen') ;
    End ;
    Varj ;

    Release(HeapTeto) ;
  End ;

Begin
  ClrScr ;
  Write('Listzand katalgus: ') ;
  ReadLn(Listazando) ;
  While Listazando <> '-' Do
    Begin
      KatalogusLista(Listazando) ;
      ClrScr ;
      Write('Listzand katalgus: ') ;
      ReadLn(Listazando) ;
    End ;
End.
