{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{                MEM11.PAS                }
{-----------------------------------------}

Program Mem11 ;

{$M 16384,0,655360}

Uses
  Crt ;

Type
  St80    = String[80] ;
  KarHely = Record
              Kar  : Char ;
              Attr : Byte ;
            End ;
  KepTip  = Array[1..25,1..80] Of KarHely ;

Var
  Kep        : ^KepTip ;	
  AblakCim   : Pointer ;	
  EX,EY,				
  ETextAttr  : Byte ;
  EWindMin,				
  EWindMax   : Word ;		
  I          : Byte ;

Procedure MemIras(X, Y: Byte ; St: St80) ;
  Var
    L,
    I : Byte ;
  Begin
    Y := Y + WindMin Shr 8 ;
    X := X + WindMin And $FF ;

    L := Length(St) ;
    For I := 1 To L do
      Begin
        Kep^[Y,X - 1 + I].Attr := TextAttr ;
        Kep^[Y,X - 1 + I].Kar := St[I] ;
      End ;
  End ;

Function Vonal(Jel: Char ; N: Byte): St80 ;
  Var
    I : Byte ;
  Begin
    For I := 1 to N Do
      Vonal[I] := Jel ;
    Vonal[0] := Char(N) ;
  End ;

Function Mutato(P : Pointer ; Rel : LongInt) : Pointer ;
  Var
    L : LongInt ;
  Begin
    L := LongInt(16) * Seg(P^) + Ofs(P^) + Rel ;
    Mutato := Ptr(L Shr 4,L And $0F) ;
  End ;

Procedure AblakKeszit(Xk,Yk,Szel,Mag,HatterSzin,KarSzin: Byte) ;
  Var
    Hmutato  : Word ;		
    Atvitel,			
    I        : Byte ;
    S        : st80 ;
  Begin
    Atvitel := Szel * 2 ;
    GetMem(AblakCim,Atvitel * Mag) ;
    Hmutato := 0 ;
    For I := Yk To Yk + Mag - 1 Do
      Begin
        Move(Kep^[I,Xk],Mutato(AblakCim,Hmutato)^,Atvitel) ;
        Inc(Hmutato,Atvitel) ;
      End ;

    If LastMode = Mono
    Then
      TextAttr := $07
    Else
      TextAttr := HatterSzin Shl 4 Or KarSzin ;

    Window(Xk,Yk,Xk + Szel - 1,Yk + Mag - 1) ;
    S := #201 + Vonal(#205,Szel - 2) + #187 ;
    MemIras(1,1,S) ;
    S := #186 + Vonal(' ',Szel - 2) + #186 ;
    For I := 2 To Mag - 1 Do
      MemIras(1,I,S) ;
    S := #200 + Vonal(#205,Szel - 2) + #188 ;
    MemIras(1,Mag,S) ;
    Window(Xk + 1,Yk + 1,Xk + Szel - 2,Yk + Mag - 2) ;
    GotoXY(1,1) ;
  End ;

Procedure AblakVissza(Xk, Yk, Szel, Mag: Byte) ;
  Var
    Hmutato  : Word ;		
    Atvitel,			
    I        : Byte ;
  Begin
    Atvitel := Szel * 2 ;
    Hmutato := 0 ;
    For I := Yk To Yk + Mag - 1 Do
      Begin
        Move(Mutato(AblakCim,Hmutato)^,Kep^[I,Xk],Atvitel) ;
        Inc(Hmutato,Atvitel) ;
      End ;
    FreeMem(AblakCim,Hmutato) ;
  End ;

Begin
  EWindMin := WindMin ;
  EWindMax := WindMax ;
  EtextAttr := TextAttr ;
  EX := WhereX ;
  EY := WhereY ;

  Kep := Ptr($B000 + Ord(LastMode <> Mono) * $800,0) ;

  AblakKeszit(5,10,40,15,Brown,Black) ;
  For I := 1 to 10 Do
    MemIras(1,I,'  Micsoda ablaktechnika !!!') ;
  MemIras(1,12,'Vigyzat! A kurzor fent van! <ENTER>') ;
  Repeat
  Until ReadKey = #13 ;

  AblakVissza(5,10,40,15) ;
  WindMin := EWindMin ;
  WindMax := EWindMax ;
  TextAttr := ETextAttr ;
  GotoXY(EX,EY) ;

  WriteLn('<ENTER>') ;
  Repeat
  Until ReadKey = #13 ;
End.
