{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{                MEM4.PAS                 }
{-----------------------------------------}

Program Mem4 ;

Uses
  Crt ;

Type
  Kapcsolo = (Be,Ki,Valt) ;
  KepTip   = Array [1..25 * 80,1..2] Of Byte ;

Var
  Kep : KepTip Absolute $B800:0 ;
  Kar : Char ;

Procedure TeleIr(ElsoSor,UtolsoSor: Byte; Kar: Char) ;
  Var
    I : Word ;
  Begin
    For I := (ElsoSor - 1) * 80 + 1 To UtolsoSor * 80 Do
      Begin
        Kep[I,1] := Byte(Kar) ;
        Kep[I,2] := 16 * Red + Black ;
      End ;
  End ;

Procedure Villogas(Oszlop, Sor: Byte ; Hossz: Word ;
                   Kapcs: Kapcsolo) ;
  Var
    Kezd,
    I     : Word ;
  Begin
    Kezd := (Sor - 1) * 80 + Oszlop ;
    For I := Kezd To Kezd + Hossz - 1 Do
      Case Kapcs Of
        Be   : Kep[I,2] := Kep[I,2] Or $80 ;
        Ki   : Kep[I,2] := Kep[I,2] And $7F ;
        Valt : Kep[I,2] := Kep[I,2] Xor $80 ;
      End ;
  End ;

Begin
  If LastMode = 7 Then
    Begin
      WriteLn('A kperny cme $B000:0 !') ;
      ReadLn ;
      Halt ;
    End ;

  ClrScr ;
  TeleIr(5,15,'b') ;

  GotoXY(5,24) ;
  Write('1-Balvillog 2-Balnemvillog 3-JobbVillog' +
        ' 4-Jobbnemvillog 5-Vlt  Esc-Vge') ;
  Repeat
      Kar := ReadKey ;
      Case Kar Of
        '1' : Villogas(1,10,40,Be) ;
        '2' : Villogas(1,10,40,Ki) ;
        '3' : Villogas(41,10,40,Be) ;
        '4' : Villogas(41,10,40,Ki) ;
        '5' : Villogas(1,10,80,Valt) ;
      End ;
  Until Kar = #27 ;

  ClrScr ;
End.
