{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{              TIPALL10.PAS               }
{-----------------------------------------}

Program Tipall10 ;

Uses
  Crt ;

Type
  St3       = String[3] ;
  St80      = String[80] ;
  Karhalmaz = Set Of Char ;
  AruTip    = Record
                Ervenyes : Boolean ;
                Kod      : St3 ;
                Nev      : String[15] ;
                Egysegar : Real ;
              End ;

Var
  Aruk    : File Of AruTip ;
  Aru     : AruTip ;
  Arukod  : St3 ;
  Puffer  : Array[1..17] Of Char ;
  Menukar,
  Valasz  : Char ;
  Pozicio : LongInt ;

Procedure Mezo_Szoveg ;
  Begin
    ClrScr ;
    GotoXY(25,10) ; Write('rukd   : ') ;
    GotoXY(25,12) ; Write('runv   : ') ;
    GotoXY(25,14) ; Write('Egysgr : ') ;
  End ;

Procedure Kod_Beolvas ;
  Begin
    SetTextBuf(Input,Puffer,SizeOf(AruKod)+1) ;
    Repeat
        GotoXY(36,10) ;
        ClrEol ;
        ReadLn(Arukod) ;
    Until (Length(Arukod) = SizeOf(Arukod)-1) And
          (Arukod[1] In ['A'..'Z']) ;
  End ;

Procedure Egyeb_Beolvas ;
  Begin
    SetTextBuf(Input,Puffer,SizeOf(Aru.Nev)+1) ;
    GotoXY(36,12) ;
    ClrEol ;
    ReadLn(Aru.Nev) ;
    SetTextBuf(Input,Puffer,8) ;
    {$I-}
    Repeat
        GotoXY(36,14) ;
        ClrEol ;
        ReadLn(Aru.Egysegar) ;
    Until IOResult = 0 ;
    {$I+}
  End ;

Procedure Egyeb_Kiir ;
  Begin
    GotoXY(36,12) ; Write(Aru.Nev) ;
    GotoXY(36,14) ; Write(Aru.Egysegar:9:2) ;
  End ;

Function Van(Kod : St3 ; Var Poz: LongInt): Boolean ;
  Var
    Megvan : Boolean ;
  Begin
    Seek(Aruk,0) ;
    Megvan := False ;
    While Not Eof(Aruk) And Not Megvan Do
      Begin
        Read(Aruk,Aru) ;
        Megvan := (Aru.Kod = Kod) And Aru.Ervenyes ;
      End ;
    Poz := FilePos(Aruk) ;
    If Megvan Then
      Dec(Poz) ;
    Van := Megvan ;
  End ;

Procedure Uzenet(Szoveg: St80 ; Valaszok: Karhalmaz ;
                 Var Valasz: Char) ;
  Begin
    GotoXY(25,24) ; Write(Szoveg) ;
    Repeat
      Valasz := Upcase(ReadKey) ;
    Until Valasz In Valaszok ;
    GotoXY(30,24) ;
    ClrEol ;
  End ;

Procedure Lista ;
  Var
    I : LongInt ;

  Procedure Lapfej ;
    Begin
      ClrScr ;
      WriteLn('rukd     runv                  Egysgr') ;
      WriteLn('') ;
    End ;

  Begin
    Lapfej ;
    Seek(Aruk,0) ;
    For I := 1 To FileSize(Aruk) Do
      Begin
        If WhereY = 23 Then
          Begin
            Write('<ENTER>') ;
            Repeat
            Until ReadKey = #13 ;
            LapFej ;
          End ;
        Read(Aruk,Aru) ;
        With Aru Do
          If Ervenyes Then
            Begin
              GotoXY( 2,WhereY) ; Write(Kod) ;
              GotoXY(10,WhereY) ; Write(Nev) ;
              GotoXY(34,WhereY) ; WriteLn(Egysegar:9:2) ;
            End ;
      End ;
    Write('<ENTER>') ;
    Repeat
    Until ReadKey = #13 ;
  End ;

Procedure Surit ;
  Var
    UjAruk : File Of AruTip ;
  Begin
    Assign(UjAruk,'\Adatok\UjAruk.Dat') ;
    Rewrite(UjAruk) ;
    Seek(Aruk,0) ;
    While Not Eof(Aruk) Do
      Begin
        Read(Aruk,Aru) ;
        If Aru.Ervenyes Then
          Write(UjAruk,Aru) ;
      End ;
    Close(Aruk) ;
    Close(UjAruk) ;
    Erase(Aruk) ;
    Rename(UjAruk,'\Adatok\Aruk.Dat') ;
  End ;

Begin
  Assign(Aruk,'\Adatok\Aruk.Dat') ;
  {$I-}
  Reset(Aruk) ;
  {$I+}
  If IOResult <> 0 Then
    Rewrite(Aruk) ;

  Repeat
      ClrScr ;
      GotoXY(18, 6) ;
      Write(' R U K    K A R B A N T A R T  S A') ;
      GotoXY(25,10) ; Write('Felvitel...........F') ;
      GotoXY(25,12) ; Write('Trls.............T') ;
      GotoXY(25,14) ; Write('Mdosts..........M') ;
      GotoXY(25,16) ; Write('Lista..............L') ;
      GotoXY(25,18) ; Write('Vge...............V') ;

      Menukar := Upcase(ReadKey) ;
      Case Menukar Of
        'F' : Begin
                Mezo_Szoveg ;
                Kod_Beolvas ;
                If Van(Arukod,Pozicio)
                Then
                  Uzenet('Mr van ilyen ru <ESC>',[#27],Valasz)
                Else
                  Begin
                    Aru.Ervenyes := True ;
                    Aru.Kod := Arukod ;
                    Egyeb_Beolvas ;
                    Seek(Aruk,FileSize(Aruk)) ;
                    Write(Aruk,Aru) ;
                  End ;
              End ;
        'T' : Begin
                Mezo_Szoveg ;
                Kod_Beolvas ;
                If Van(Arukod,Pozicio)
                Then
                  Begin
                    Egyeb_Kiir ;
                    Uzenet('Trljem? (I/N)',['I','N'],Valasz);
                    If Valasz = 'I' Then
                      Begin
                        Aru.Ervenyes := False ;
                        Seek(Aruk,Pozicio) ;
                        Write(Aruk,Aru) ;
                      End ;
                  End
                Else
                  Uzenet('Nincs ilyen ru <ESC>',[#27],Valasz);
              End ;
        'M' : Begin
                Mezo_Szoveg ;
                Kod_Beolvas ;
                If Van(Arukod,Pozicio)
                Then
                  Begin
                    Egyeb_Kiir ;
                    Uzenet('Mdostsam? (I/N)',['I','N'],Valasz) ;
                    If Valasz = 'I' Then
                      Begin
                        Egyeb_Beolvas ;
                        Seek(Aruk,Pozicio) ;
                        Write(Aruk,Aru) ;
                      End
                  End
                Else
                  Uzenet('Nincs ilyen ru <ESC>',[#27],Valasz);
              End ;
        'L' : Lista ;
      End ;
  Until Menukar = 'V' ;

  ClrScr ;
  Surit ;
End.
