{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{              TIPALL11.PAS               }
{-----------------------------------------}

Program Tipall11 ;

Type
  SzallitasTip = Record
                   Arukod    : String[ 3] ;
                   Irszam    : String[ 4] ;
                   Cim       : String[30] ;
                   Mennyiseg : LongInt ;
                 End ;
  ElemTip      = Record
                   Kulcs      : String[5] ;
                   Rekordszam : LongInt ;
                 End ;

Var
  Szallitasok,
  Rendezett     : File Of SzallitasTip ;
  Szallitas     : SzallitasTip ;
  AllomanyMeret,
  I             : Word ;
  Tomb          : Array [1..5000] Of ElemTip ;

Procedure Quick_Rendez ;

  Procedure Csere(Var Elem1, Elem2: ElemTip) ;
    Var
      Ment : ElemTip ;
    Begin
      Ment := Elem1 ;
      Elem1 := Elem2 ;
      Elem2 := Ment ;
    End ;

  Procedure Quick(Bal,Jobb: Word) ;
    Var
      I, 
      J            : Word ;
      KozepsoKulcs : String[5] ;
    Begin
      I := Bal ;
      J := Jobb ;
      KozepsoKulcs := Tomb[(I + J) Div 2].Kulcs ;
      While I <= J Do
        Begin
          While Tomb[I].Kulcs < KozepsoKulcs Do
            Inc(I) ;
          While Tomb[J].Kulcs > KozepsoKulcs Do
            Dec(J) ;
          If I <= J Then
            Begin
              Csere(Tomb[I],Tomb[J]) ;
              Inc(I) ;
              Dec(J) ;
            End ;
        End ;
      If Bal < J Then
        Quick(Bal,J) ;
      If I < Jobb Then
        Quick(I,Jobb) ;
    End ;

  Begin
    Quick(1,AllomanyMeret) ;
  End ;

Begin
  Assign(Szallitasok,'\Adatok\Szallit.Bp') ;
  {$I-}
  Reset(Szallitasok) ;
  {$I+}
  If IOResult <> 0 Then
    Begin
      WriteLn('Nincsenek budapesti szlltsok!') ;
      ReadLn ;
      Halt ;
    End ;

  AllomanyMeret := FileSize(Szallitasok) ;
  For I := 1 To AllomanyMeret Do
    Begin
      Read(Szallitasok,Szallitas) ;
      Tomb[I].Kulcs := Szallitas.Arukod + Copy(Szallitas.Irszam,2,2) ;
      Tomb[I].Rekordszam := I - 1 ;
    End ;

  Quick_Rendez ;

  Assign(Rendezett,'\Adatok\RSzall.Bp') ;
  Rewrite(Rendezett) ;
  For I := 1 To AllomanyMeret Do
    Begin
      Seek(Szallitasok,Tomb[I].Rekordszam) ;
      Read(Szallitasok,Szallitas) ;
      Write(Rendezett,Szallitas) ;
    End ;
  Close(Szallitasok) ;
  Close(Rendezett) ;

  WriteLn('rukd   Kerlet  Mennyisg') ;
  Reset(Rendezett) ;
  For I := 1 To AllomanyMeret Do
    Begin
      Read(Rendezett,Szallitas) ;
      With Szallitas Do
        WriteLn(Arukod:4,Copy(Irszam,2,2):10,Mennyiseg:12) ;
    End ;
  Close(Rendezett) ;
  Write('<ENTER>') ;
  ReadLn ;
End.
