{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{              TIPALL12.PAS               }
{-----------------------------------------}

Program Tipall12 ;

Const
  Maxsorszam       = 50 ;
  DoltBe           = #27 + '4' ;
  DoltKi           = #27 + '5' ;
  KiemeltBe        = #27 + 'E' ;
  KiemeltKi        = #27 + 'F' ;

Type
  St3          = String[3] ;
  SzallitasTip = Record
                   Arukod : String[3] ;
                   Irszam : String[4] ;
                   Cim    : String[30] ;
                   Menny  : LongInt ;
                 End ;
  AruTip       = Record
                   Ervenyes : Boolean ;
                   Kod      : St3 ;
                   Nev      : String[15] ;
                   Egysegar : Real ;
                 End ;

Var
  MaiDatum       : String[6] ;
  Szallitasok    : File Of SzallitasTip ;
  Szallitas      : SzallitasTip ;
  Szallitas_Vege : Boolean ;
  Aruk           : File Of AruTip ;
  Aru            : AruTip ;
  Lista          : Text ;
  Kerulet,
  AktKerulet     : String[2] ;
  AktArukod      : String[3] ;
  AruPoz,
  OsszMenny,
  Aru_OsszMenny,
  Ker_OsszMenny  : LongInt ;
  OsszErtek      : Real ;
  Sorszamlalo,
  Lapszamlalo    : Byte ;

Procedure Szallitas_Olvas ;
  Begin
    Szallitas_Vege := Eof(Szallitasok) ;
    If Not Szallitas_Vege Then
      Begin
        Read(Szallitasok,Szallitas) ;
        Kerulet := Copy(Szallitas.Irszam,2,2) ;
      End ;
  End ;

Function Van(Kod : St3): Boolean ;
  Var
    Megvan : Boolean ;
  Begin
    Seek(Aruk,0) ;
    Megvan := False ;
    While Not Eof(Aruk) And Not Megvan Do
      Begin
        Read(Aruk,Aru) ;
        Megvan := (Aru.Kod = Kod) And Aru.Ervenyes ;
      End ;
    Van := Megvan ;
  End ;

Procedure Lapfej ;
  Begin
    If Lapszamlalo > 0 Then
      Write(Lista,#12) ;
    Inc(Lapszamlalo) ;
    WriteLn(Lista,KiemeltBe,'S Z  L L I T  S O K':40,
            '':15,Lapszamlalo,'. oldal',KiemeltKi) ;
    WriteLn(Lista) ;
    Sorszamlalo := 3 ;
  End ;

Procedure Aru_Fej ;
  Var
    I : Byte ;
  Begin
    If Sorszamlalo > Maxsorszam - 6 Then
      Lapfej ;
    Write(Lista, KiemeltBe) ;
    For I := 1 To 63 Do
      Write(Lista,'') ;
    WriteLn(Lista) ;
    WriteLn(Lista,' rukd: ',AktArukod,'  ru neve: ',Aru.Nev,
            '':15 - Length(Aru.Nev),'  Egysgr:',
            Aru.Egysegar:10:2,' Ft') ;
    WriteLn(Lista) ;
    Write(Lista,KiemeltKi,DoltBe) ;
    WriteLn(Lista,'          Kerlet      Mennyisg',
           '           rtk') ;
    Write(Lista,DoltKi) ;
    WriteLn(Lista,'                      ',
            '          .') ;
    Inc(Sorszamlalo,5) ;
  End ;

Procedure Kerulet_Osszesen ;
  Var
    Ertek : Real ;
  Begin
    If Sorszamlalo > Maxsorszam Then
      Lapfej ;
    Ertek := Ker_OsszMenny * Aru.Egysegar ;
    WriteLn(Lista,AktKerulet:14,'.',Ker_OsszMenny:15,Ertek:20:2) ;
    Inc(Sorszamlalo) ;
  End ;

Procedure Aru_Osszesen ;
  Var
    Ertek : Real ;
  Begin
    Ertek := Aru_OsszMenny * Aru.Egysegar ;
    OsszErtek := OsszErtek + Ertek ;
    WriteLn(Lista,'':24,'          ') ;
    WriteLn(Lista,'ru sszesen:':15,Aru_OsszMenny:15,Ertek:20:2);
    WriteLn(Lista) ;
    Inc(Sorszamlalo,3) ;
  End ;

Procedure Osszesen ;
  Var
    I     : Byte ;
  Begin
    For I := 1 To 63 Do
      Write(Lista,'') ;
    WriteLn(Lista) ;
    WriteLn(Lista,'SSZESEN:':15,OsszMenny:15,OsszErtek:20:2) ;
  End ;

Begin
  Assign(Szallitasok,'\Adatok\RSzall.Bp') ;
  Assign(Aruk,'\Adatok\Aruk.Dat') ;
  {$I-}
  Reset(Szallitasok) ;
  {$I+}
  If IOResult <> 0 Then
    Begin
      WriteLn('Nincs szllts llomny!') ;
      ReadLn ;
      Halt ;
    End ;
  {$I-}
  Reset(Aruk) ;
  {$I+}
  If IOResult <> 0 Then
    Begin
      WriteLn('Nincs ru llomny!') ;
      ReadLn ;
      Halt ;
    End ;

  Write('Mai dtum [HHNN] : ') ;
  ReadLn(MaiDatum) ;
  Assign(Lista,MaiDatum+'.Lst') ;
  Rewrite(Lista) ;
  Lapszamlalo := 0 ;
  Lapfej ;
  OsszMenny := 0 ;
  OsszErtek := 0 ;

  Szallitas_Olvas ;
  While Not Szallitas_Vege Do
    Begin
      AktArukod := Szallitas.Arukod ;
      If Not Van(AktArukod) Then
        Begin
          Aru.Nev := '' ;
          Aru.Egysegar := 0 ;
        End ;
      Aru_Fej ;
      Aru_OsszMenny := 0 ;

      While Not Szallitas_Vege And
           (Szallitas.Arukod = AktArukod) Do
        Begin
          AktKerulet := Kerulet ;
          Ker_OsszMenny := 0 ;

          While Not Szallitas_Vege And
                (Szallitas.Arukod = AktArukod) And
                (Kerulet = AktKerulet) Do
            Begin
              Inc(Ker_OsszMenny,Szallitas.Menny) ;
              Szallitas_Olvas ;
            End ;

          Inc(Aru_OsszMenny,Ker_OsszMenny) ;
          Kerulet_Osszesen ;
        End ;

      Inc(OsszMenny,Aru_OsszMenny) ;
      Aru_Osszesen ;
    End ;

  Osszesen ;
  Close(Lista) ;
End.
