{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{              TIPALL15.PAS               }
{-----------------------------------------}

Program Tipall15 ;

Uses
  Crt ;

Type
  Datum     = Record
                Ev  : Word ;
                Ho,
                Nap : Byte ;
              End ;
  Allapotok = (Foglalt,Szabad,Javitando) ;

  KamionTip = Record
                Rendszam  : String[8] ;
                Tipus     : String[10] ;
                MegtettKm : LongInt ;
                Case Allapot : Allapotok Of
                  Foglalt   : ( CelAllomas : String[5] ;
                                Vezeto     : String[15] ;
                                Visszater  : Datum ) ;
                  Szabad    : ( GarazsSzam : Byte ;
                                Terv       : String[20] ) ;
                  Javitando : ( Hiba       : String[40] ;
                                HatarIdo   : Datum )
              End ;

Var
  Kamionok   : File Of KamionTip ;
  Kamion     : KamionTip ;
  AllapotKar : Char ;

Begin
  Assign(Kamionok,'Kamion.Dat') ;
  {$I-}
  Reset(Kamionok) ;
  {$I+}
  If IOResult = 0
  Then
    Seek(Kamionok,FileSize(Kamionok))
  Else
    Rewrite(Kamionok) ;

  ClrScr ;
  WriteLn('K A M I O N O K      A D A T F E L V I T E L') ;
  Write('Rendszm    : ') ;
  ReadLn(Kamion.Rendszam) ;
  While Kamion.Rendszam <> '' Do
    With Kamion Do
      Begin
        Write('Tpus       : ') ;
        ReadLn(Tipus) ;
        Write('Megtett Km  : ') ;
        ReadLn(MegtettKm) ;

        Write('(F)oglalt/(S)zabad/(J)avtand') ;
        Repeat
          AllapotKar := Upcase(ReadKey) ;
        Until AllapotKar In ['F','S','J'] ;
        WriteLn ;
        Case AllapotKar Of
          'F' : Begin
                  Allapot := Foglalt ;
                  Write('Cllloms  : ') ;
                  ReadLn(Celallomas);
                  Write('Vezet neve : ') ;
                  ReadLn(Vezeto) ;
                  Write('Visszatr     '#13#10) ;
                  Write('      v    : ') ;
                  ReadLn(Visszater.Ev) ;
                  Write('      H    : ') ;
                  ReadLn(Visszater.Ho) ;
                  Write('      Nap   : ') ;
                  ReadLn(Visszater.Nap);
                End ;
          'S' : Begin
                  Allapot := Szabad ;
                  Write('Garzs szma: ') ;
                  ReadLn(GarazsSzam);
                  Write('Terv        : ') ;
                  ReadLn(Terv) ;
                End ;
          'J' : Begin
                  Allapot := Javitando ;
                  Write('Hiba        : ') ;
                  ReadLn(Hiba) ;
                  Write('Elkszl      '#13#10) ;
                  Write('     v     : ') ;
                  ReadLn(Hatarido.Ev) ;
                  Write('     H     : ') ;
                  ReadLn(Hatarido.Ho) ;
                  Write('     Nap    : ') ;
                  ReadLn(Hatarido.Nap) ;
                End ;
        End ;
        Write(Kamionok,Kamion) ;
        WriteLn ;
        Write('Rendszm    : ') ;
        ReadLn(Kamion.Rendszam) ;
      End ;
  Close(Kamionok) ;

  ClrScr ;
  WriteLn('   S Z A B A D   K A M I O N O K') ;
  WriteLn('Rendszm    Garzs        Terv') ;
  WriteLn ;
  Reset(Kamionok) ;
  While Not Eof(Kamionok) Do
    Begin
      Read(Kamionok,Kamion) ;
      If Kamion.Allapot = Szabad Then
        With Kamion Do
          WriteLn(Rendszam,'':13 - Length(Rendszam),
                  GarazsSzam:3,'':10,Terv) ;
    End ;
  Close(Kamionok) ;
  WriteLn ;
  WriteLn('   V  G E') ;
  ReadLn ;
End.
