{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{               TIPALL7.PAS               }
{-----------------------------------------}

Program Tipall7 ;

Uses
  Crt ;

Type
  SzallitasTip = Record
                   Arukod    : String[ 3] ;
                   Irszam    : String[ 4] ;
                   Cim       : String[30] ;
                   Mennyiseg : LongInt ;
                 End ;

Var
  Szallitasok : File Of SzallitasTip ;
  Szallitas   : SzallitasTip ;
  AktDir      : String ;
  Puffer      : Array[1..32] Of Char ;
  I           : Byte ;

Procedure Mezo_Torles ;
  Begin
    GotoXY(35,10) ; ClrEol ;
    GotoXY(35,12) ; ClrEol ;
    GotoXY(35,14) ; ClrEol ;
    GotoXY(35,16) ; ClrEol ;
  End ;

Procedure Arukod_Beolvas ;
  Begin
    SetTextBuf(Input,Puffer,5) ;
    With Szallitas Do
      Repeat
          GotoXY(35,10) ;
          ClrEol ;
          ReadLn(Arukod) ;
      Until (Length(Arukod) = 3) And (Arukod[1] In ['A'..'Z']) Or
            (Arukod = '') ;
  End ;

Procedure Irszam_Beolvas ;
  Var
    JoIrszam : Boolean ;
    Szam     : Word ;
    Kod      : Integer ;
  Begin
    SetTextBuf(Input,Puffer,6) ;
    With Szallitas Do
      Repeat
          GotoXY(35,12) ;
          ClrEol ;
          ReadLn(Irszam) ;
          JoIrszam := (Irszam >= '1000') And (Irszam <= '9999') ;
          If JoIrszam And (Irszam[1] = '1') Then
            Begin
              Val(Copy(Irszam,2,2),Szam,Kod) ;
              JoIrszam := Szam In [1..22] ;
            End ;
      Until JoIrszam ;
  End ;

Procedure Cim_Beolvas ;
  Begin
    SetTextBuf(Input,Puffer,32) ;
    GotoXY(35,14) ;
    ReadLn(Szallitas.Cim) ;
  End ;

Procedure Mennyiseg_Beolvas ;
  Begin
    SetTextBuf(Input,Puffer,8) ;
    {$I-}
    Repeat
        GotoXY(35,16) ;
        ClrEol ;
        ReadLn(Szallitas.Mennyiseg) ;
    Until (IOResult = 0) And (Szallitas.Mennyiseg >= 0) ;
    {$I+}
  End ;

Begin
  GetDir(0,AktDir) ;
  {$I-}
  ChDir('\Adatok') ;
  If IOResult <> 0 Then
    Begin
      MkDir('\Adatok') ;
      If IOResult <> 0 Then
        Begin
          WriteLn('Az alknyvtrat nem sikerlt ltrehozni') ;
          ReadLn ;
          Halt ;
        End ;
      ChDir('\Adatok') ;
    End ;
    Assign(Szallitasok,'Szallit.Dat') ;
  Reset(Szallitasok) ;
  {$I+}
  If IOResult = 0
  Then
    Seek(Szallitasok,Filesize(Szallitasok))
  Else
    Rewrite(Szallitasok) ;

  ClrScr ;
  GotoXY(20,10) ; Write('rukd       :') ;
  GotoXY(20,12) ; Write('Irnytszm :') ;
  GotoXY(20,14) ; Write('Cm          :') ;
  GotoXY(20,16) ; Write('Mennyisg    :') ;
  Arukod_Beolvas ;
  While Szallitas.Arukod <> '' Do
    Begin
      Irszam_Beolvas ;
      Cim_Beolvas ;
      Mennyiseg_Beolvas ;
      Write(Szallitasok,Szallitas) ;
      Mezo_Torles ;
      Arukod_Beolvas ;
    End ;
  Close(Szallitasok) ;

  ClrScr ;
  WriteLn('rukd','Irszm':8,'Cm':10,'Mennyisg':38) ;
  For I := 1 To 62 Do
    Write('-') ;
  WriteLn ;
  Reset(Szallitasok) ;
  While Not Eof(Szallitasok) Do
    Begin
      Read(Szallitasok,Szallitas) ;
      With Szallitas Do
        Begin
          GotoXY( 2,WhereY) ; Write(Arukod) ;
          GotoXY(10,WhereY) ; Write(Irszam) ;
          GotoXY(20,WhereY) ; Write(Cim) ;
          GotoXY(55,WhereY) ; WriteLn(Mennyiseg:6) ;
        End ;
    End ;
  WriteLn ;
  WriteLn('sszesen: ',FileSize(Szallitasok),' szllts') ;
  Close(Szallitasok) ;

  ChDir(AktDir) ;
  ReadLn ;
End.
