{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{              TIPNELK3.PAS               }
{-----------------------------------------}

Program Tipnelk3 ;

Uses
  Crt ;

Const
  MaxBajtSzam = 20000 ;

Type
  St2 = String[2] ;

Var
  Ismeretlen          : File ;
  Sorszamlalo         : Byte ;
  Kezd,
  SorMutato,
  BajtSzam,
  Beolvasott_Bajtszam : Word ;
  Kod                 : Integer ;
  Puffer              : Array[1..MaxBajtSzam] Of Byte ;
  Ch                  : Char ;

Function Hex(B: Byte) : St2 ;
  Const
    HexJegy : Array [0..15] Of Char = '0123456789ABCDEF' ;
  Begin
    Hex := HexJegy[B Div 16] + HexJegy[B Mod 16] ;
  End ;

Procedure Utmutatas ;
  Begin
    WriteLn('Hasznlat: TIPNELK3 <llomnyspec> <Bjtszm (1-',
            MaxBajtSzam,')>') ;
    ReadLn ;
    Halt ;
  End ;

Begin
  If ParamCount <> 2 Then
    Utmutatas ;
  Val(ParamStr(2),BajtSzam,Kod) ;
  If Kod <> 0 Then
    Utmutatas ;
  If BajtSzam > MaxBajtSzam Then
    BajtSzam := MaxBajtSzam ;
  Assign(Ismeretlen,ParamStr(1)) ;
  {$I-}
  Reset(Ismeretlen,1) ;
  {$I+}
  If IOResult <> 0 Then
    Utmutatas ;

  BlockRead(Ismeretlen,Puffer,BajtSzam,Beolvasott_BajtSzam) ;

  ClrScr ;
  WriteLn('A ''',ParamStr(1),''' els ',Beolvasott_BajtSzam,
          ' bjtja:') ;
  WriteLn ;
  Sorszamlalo := 0 ;
  Kezd := 1 ;
  While Kezd <= Beolvasott_Bajtszam Do
    Begin
      SorMutato := 0 ;
      While (SorMutato < 26) And
            (Kezd + SorMutato <= Beolvasott_BajtSzam) Do
        Begin
          Write(Hex(Puffer[Kezd + SorMutato]):3) ;
          Inc(SorMutato) ;
        End ;
      WriteLn ;
      SorMutato := 0 ;
      While (SorMutato < 26) And
            (Kezd + SorMutato <= Beolvasott_BajtSzam) Do
        Begin
          Ch := Chr(Puffer[Kezd + SorMutato]) ;
          If Not(Ch In [Chr(0)..Chr(31),Chr(127)])
          Then
            Write(Ch:3)
          Else
            Write('.':3) ;
          Inc(SorMutato) ;
        End ;
      WriteLn ;
      Inc(Sorszamlalo) ;
      If Sorszamlalo = 7 Then
        Begin
          ReadLn ;
          ClrScr ;
          Sorszamlalo := 0 ;
        End ;
      Kezd := Kezd + 26 ;
      WriteLn ;
    End ;
  ReadLn ;
End.
