{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{                TOMB6.PAS                }
{-----------------------------------------}

Program Tomb6 ;

{$V-}

Uses
  Crt ;

Type
  Szinek = (Feher, Sarga, Narancs, Piros,
            Lila, Kek, Zold, Fekete) ;

Const
  SzinSt : Array[Szinek] Of String[8] =
             ('Feher','Sarga','Narancs','Piros',
              'Lila','Kek','Zold','Fekete') ;

Var
  Szin   : Szinek ;
  Gyujto : Array[Szinek] Of Word ;
  Osszes : Word ;
  St     : String[8] ;

Procedure Atalakit(Var S : String) ;
  Var
    I : Byte ;
  Begin
    S[1] := UpCase(S[1]) ;
    For I := 2 To Length(S) Do
      If S[I] In ['A'..'Z'] Then
        S[I] := Chr(Ord(S[I]) + (Ord('a') - Ord('A'))) ;
  End ;

Begin
  For Szin := Feher To Fekete Do
    Gyujto[Szin] := 0 ;

  ClrScr ;
  WriteLn('Krem a szneket: ') ;
  ReadLn(St) ;
  While St <> '' Do
    Begin
      Atalakit(St) ;
      Szin := Feher ;
      While (Szin < Fekete) And (St <> SzinSt[Szin]) Do
        Inc(Szin) ;
      If St = SzinSt[Szin] Then
        Inc(Gyujto[Szin]) ;
      ReadLn(St) ;
    End ;

  Osszes := 0 ;
  For Szin := Feher To Fekete Do
    Osszes := Osszes + Gyujto[Szin] ;

  WriteLn('KIMUTATS A BEOLVASOTT SZINEKRL') ;
  WriteLn(' Szn    Db          %') ;
  WriteLn ;
  For Szin := Feher To Fekete Do
    Begin
      Write(SzinSt[Szin]) ;
      GotoXY(10,WhereY) ;
      Write(Gyujto[Szin]:2) ;
      GotoXY(20,WhereY) ;
      If Osszes <> 0 Then
        Write(Gyujto[Szin] * 100.0 / Osszes:5:1) ;
      WriteLn ;
    End ;
  ReadLn ;
End.
