{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{               TOMB15.PAS                }
{-----------------------------------------}

Program Tomb15 ;

Uses
  Crt ;

Var
  Db          : Array [1..5] Of Array [0..9] Of Byte ;
  Szam        : LongInt ;
  Puffer      : Array [1..7] Of Byte ;

Procedure SzamOlvas ;
  Var
    OK     : Boolean ;
    SzamSt : String[5] ;
    Kod    : Integer ;
  Begin
    WriteLn ;
    Repeat
        GotoXY(3,WhereY - 1) ;
        ClrEol ;
        ReadLn(SzamSt) ;
        Val(SzamSt,Szam,Kod) ;
        OK := (Kod = 0) And (Szam >= 0) ;
        If Not OK Then
          Write(#7) ;
    Until OK ;
  End ;

Procedure SzamFeldolgoz ;
  Var
    Sz : LongInt ;
    Vegzodes    : 0..9 ;
    Jegyekszama : 0..5 ;
  Begin
    Vegzodes := Szam Mod 10 ;
    Sz := Szam ;
    Jegyekszama := 0 ;
    Repeat
        Sz := Sz Div 10 ;
        Inc(Jegyekszama) ;
    Until Sz = 0 ;

    Inc(Db[Jegyekszama,Vegzodes]) ;
  End ;

Procedure FuggIr(X, Y: Byte ; Szoveg: String) ;
  Var
    I : Byte ;
  Begin
    For I := 1 To Length(Szoveg) Do
      Begin
        GotoXY(X,Y + I) ;
        Write(Szoveg[I]) ;
      End ;
  End ;

Procedure TablazatKeszit ;
  Var
    Vegzodes    : 0..9 ;
    Jegyekszama : 0..5 ;
  Begin
    TextColor(Yellow) ;
    GotoXY(48,5) ;
    Write('V  g z  d  s') ;
    GotoXY(40,6) ;
    For Vegzodes := 0 To 9 Do
      Write(Vegzodes:3) ;
    FuggIr(33,6,'Jegyek szma') ;
    For Jegyekszama := 1 To 5 Do
      Begin
        GotoXY(38,6 + 2 * Jegyekszama) ;
        Write(Jegyekszama) ;
      End ;

    TextColor(Black) ;
    For Jegyekszama := 1 To 5 Do
      Begin
        GotoXY(40,6 + 2 * Jegyekszama) ;
        For Vegzodes := 0 To 9 Do
          Write(Db[Jegyekszama,Vegzodes]:3) ;
      End ;
  End ;

Begin
  TextBackground(LightGray) ;
  TextColor(Blue) ;
  ClrScr ;

  FillChar(Db,SizeOf(Db),#0) ;

  WriteLn('Krem a szmokat (0 = vge):') ;
  SetTextBuf(Input,Puffer) ;
  SzamOlvas ;
  While Szam <> 0 Do
    Begin
      SzamFeldolgoz ;
      SzamOlvas ;
    End ;

  TablazatKeszit ;
  ReadLn ;
  TextBackground(Black) ;
  TextColor(LightGray) ;
  ClrScr ;
End.
