{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{               TOMB16.PAS                }
{-----------------------------------------}

Program Tomb16 ;

Uses
  Crt ;

Const
  MaxOrszag = 20 ;
  Tol       = 1970 ;
  Ig        = 1980 ;

Type
  St15         = String[15] ;
  ResztvevoTip = Record
                   Nev       : String[25] ;
                   SzulEv    : Word ;
                   OrszagNev : St15 ;
                 End ;

Var
  Letszam     : Array[1..MaxOrszag,Tol..Ig] Of Word ;
  OrszagNevek : Array[1..MaxOrszag] Of St15 ;
  OrszagSzam  : Byte ;
  Resztvevok  : File Of ResztvevoTip ;
  Resztvevo   : ResztvevoTip ;

Procedure Ujresztvevok ;
  Var
    Ev : LongInt ;
    Y  : Byte ;
  Begin
    {$I-}
    Reset(Resztvevok) ;
    {$I+}
    If IOResult = 0
    Then
      Seek(Resztvevok,FileSize(Resztvevok))
    Else
      Rewrite(Resztvevok) ;

    ClrScr ;
    With Resztvevo Do
      Begin
        Write('Nv               : ') ;
        ReadLn(Nev) ;
        While Nev <> '' Do
          Begin
            {$I-}
            Write('Szl.v(',Tol,'-',Ig,'): ') ;
            Y := WhereY ;
            Repeat
                GotoXY(20,Y) ;
                ClrEol ;
                ReadLn(Ev) ;
            Until (IOResult = 0) And (Ev >= Tol) And (Ev <= Ig) ;
            {$I+}
            SzulEv := Ev ;
            Write('Orszgnv         : ') ;
            ReadLn(OrszagNev) ;
            Write(Resztvevok,Resztvevo) ;
            WriteLn ;
            Write('Nv               : ') ;
            ReadLn(Nev) ;
          End ;
      End ;
    Close(Resztvevok) ;
  End ;

Function Letezik(Onev: St15 ; Var Pozicio: Byte): Boolean ;
  Begin
    Pozicio := 1 ;
    {$B-}
    While (Pozicio <= OrszagSzam) And (Onev > OrszagNevek[Pozicio]) Do
      Inc(Pozicio) ;
    Letezik := (Pozicio <= OrszagSzam) And (Onev = OrszagNevek[Pozicio]) ;
    {$B+}
  End ;

Procedure Gyujtes ;
  Var
    I,
    N : Byte ;
    J : Word ;
  Begin
    {$I-}
    Reset(Resztvevok) ;
    {$I+}
    If IOResult <> 0 Then
      Exit ;
    FillChar(Letszam, SizeOf(Letszam),#0) ;
    OrszagSzam := 0 ;
    While Not Eof(Resztvevok) Do
      With Resztvevo Do
        Begin
          Read(Resztvevok,Resztvevo) ;
          If Letezik(OrszagNev,N)
          Then
            Inc(Letszam[N,SzulEv])
          Else
            Begin
              If (OrszagSzam < MaxOrszag) Then
                Begin
                  For I := OrszagSzam DownTo N Do
                    Begin
                      OrszagNevek[I + 1] := OrszagNevek[I] ;
                      Letszam[I + 1] := Letszam[I] ;
                    End ;
                  OrszagNevek[N] := OrszagNev ;
                  For J := Tol To Ig Do
                    Letszam[N,J] := 0 ;
                  Inc(OrszagSzam) ;
                  Inc(Letszam[N,SzulEv]) ;
                End ;
            End ;
        End ;
    Close(Resztvevok) ;
  End ;

Procedure Kimutatas ;
  Var
    I         : Byte ;
    J,
    Osszes,
    VegOsszes : Word ;
  Begin
    ClrScr ;
    GotoXY(18,3) ;
    For J := Tol To Ig Do
      Write(J:5) ;
    Write('    ssz') ;
    For I := 1 To OrszagSzam Do
      Begin
        GotoXY(2,I + 4) ;
        Write(OrszagNevek[I]) ;
        Osszes := 0 ;
        GotoXY(17,WhereY) ;
        For J := Tol To Ig Do
          Begin
            Write(Letszam[I,J]:5) ;
            Inc(Osszes,Letszam[I,J]) ;
          End ;
        Write(Osszes:8) ;
      End ;
    GotoXY(18,5 + OrszagSzam) ;
    For I := 1 To 63 Do
      Write('') ;
    VegOsszes := 0 ;
    GotoXY(17,6 + OrszagSzam) ;
    For J := Tol To Ig Do
      Begin
        Osszes := 0 ;
        For I := 1 To OrszagSzam Do
          Inc(Osszes,Letszam[I,J]) ;
        Write(Osszes:5) ;
        Inc(VegOsszes,Osszes) ;
      End ;
    Write(VegOsszes:8) ;
    ReadLn ;
  End ;

Begin
  Assign(Resztvevok,'Resztv.Dat') ;
  Ujresztvevok ;
  Gyujtes ;
  Kimutatas ;
End.
